#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <stddef.h>
#include <string.h>
#include <eikappui.h>
#include <eikenv.h>
#include <reent.h>
#include <bautils.h>
#include <stdlib.h>
#include <sdl.h>
#include "gp2x.h"
#include "input.h"
static char KDataDir[256] = "e:\\resource\\apps\\uae4all\\";

struct SymbianDirent {
	TUint32 d_fileno;		/* file number of entry */
	TUint16 d_reclen;		/* length of this record */
	TUint8  d_type; 		/* file type, see below */
	TUint8  d_namlen;		/* length of string in d_name */
	char	d_name[255 + 1];	/* name must be no longer than this */
};

/*
 * File types
 */
#define	DT_UNKNOWN	 0
#define	DT_FIFO		 1
#define	DT_CHR		 2
#define	DT_DIR		 4
#define	DT_BLK		 6
#define	DT_REG		 8
#define	DT_LNK		10
#define	DT_SOCK		12
#define	DT_WHT		14

class CUAE4AllApp: public CSDLApp {
public:
	CUAE4AllApp();
   	~CUAE4AllApp();
#ifdef UIQ3	
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 	 * @return TInt, resource id
   	*/
	TInt ViewResourceId();
#endif	
	TUid AppDllUid() const;

	/**
	 * This has a default empty implementation.
	 * Is called just before SDL_Main is called to allow init of system vars
	 */
	void PreInitializeAppL()
	{
		KDataDir[0] = BitmapStoreName()[0];
	}
};

#ifndef S60
CApaApplication* NewApplication() {
	// Return pointer to newly created CQMApp
	return new CUAE4AllApp;
}

#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}

#endif
CUAE4AllApp::CUAE4AllApp() {
}

CUAE4AllApp::~CUAE4AllApp() {
	CloseSTDLIB();
}

#ifdef UIQ3
#include <UAE4All.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CUAE4AllApp::ViewResourceId() {
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif
/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CUAE4AllApp::AppDllUid() const {
	return TUid::Uid(0xA000A000);
}



/////////////////////////////////////////////////////////////////////////////////////////////////
char currentDir[300];
char launchDir[300];
int GFXVIDINFO_HEIGHT=240;
int enableHWscaling = 0;
extern SDL_Joystick *uae4all_joy0;
struct joy_range
{
    int minx, maxx, miny, maxy;
};
extern struct joy_range range0;

char* DataPrefix()
{
	return KDataDir;
}

unsigned long gp2x_joystick_read(int )
{
	unsigned long value = 0;
	SDL_Event event;

	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_JOYBUTTONDOWN)
		{
			switch (event.jbutton.button)
			{
			case 0:value|=GP2X_B;break;
			case 1:value|=GP2X_SELECT;break;
			}
		}
		else if (event.type == SDL_KEYDOWN)
		{
			switch(event.key.keysym.sym)
			{
			case SDLK_RIGHT: value|=GP2X_RIGHT; break;
			case SDLK_LEFT: value|=GP2X_LEFT; break;
			case SDLK_UP: value|=GP2X_UP; break;
			case SDLK_DOWN:value|=GP2X_DOWN; break;
			case SDLK_1:value|=GP2X_PUSH;
			case SDLK_RETURN:value|=GP2X_B; break;
			case SDLK_SPACE: value|=GP2X_SELECT; break;
			case SDLK_ESCAPE: value|=GP2X_START; break;
			case SDLK_2:value|=GP2X_Y; break;
			case SDLK_3:value|=GP2X_A; break;
			case SDLK_4:value|=GP2X_X; break;
			default:
				break;

			}
		}
	}
	
	SDL_JoystickUpdate();
	SDL_Joystick *joy = uae4all_joy0;
	int x_axis, y_axis; 
	struct joy_range *r = &range0;
    x_axis = SDL_JoystickGetAxis (joy, 0);
    y_axis = SDL_JoystickGetAxis (joy, 1);
    
    if (x_axis < 0)
    	value|=GP2X_LEFT;
    else if (x_axis > 0)
		value|=GP2X_RIGHT;

    if (y_axis < 0)
		value|=GP2X_UP; 
    else if (y_axis > 0)
    	value|=GP2X_DOWN;
    
	/* Interval for checking key/joy events */
	if (!CheckKeyJoyRefresh(
			value&GP2X_LEFT, value&GP2X_RIGHT, value&GP2X_UP, value&GP2X_DOWN,
			0, 0, 0, 0, 0, 0,
			0))
		return 0;
	
	return value;
}

void update_joystick(int& left, int& right, int& up, int& down)
{		
	SDL_Joystick *joy = uae4all_joy0;
	int x_axis, y_axis; 	
    x_axis = SDL_JoystickGetAxis (joy, 0);
    y_axis = SDL_JoystickGetAxis (joy, 1);
    
    if (x_axis < 0)
    	left = 1;
    else if (x_axis > 0)
		right = 1;

    if (y_axis < 0)
		up = 1;
    else if (y_axis > 0)
    	down = 1;
}

void setBatteryLED(int )
{

}

int gp2xMouseEmuOn=1;
int gp2xButtonRemappingOn=0;



int	 SymbianScandir(const char * aPath, struct SymbianDirent *** aDirEntList,
	    int (*)(struct SymbianDirent *), int (*)(const void *, const void *))
{
	TInt cnt = 0;
	TFileName path;
	TPtrC8 ptr((const unsigned char*) (aPath), strlen(aPath));
	path.Copy(ptr);
	
	if(path.Length() == 0)
	{		
		TDriveList driveList;
		TFileName driveLetter;	
		TInt countedDrives=0;
		CEikonEnv::Static()->FsSession().DriveList(driveList);

		for(TInt drive=0;drive<driveList.Length();drive++)
		{
			if(driveList[drive]!=0)
			{
				countedDrives++;
			}			
		}	
			
		*aDirEntList = (struct SymbianDirent **) malloc(countedDrives*sizeof(struct SymbianDirent**));
		countedDrives=0;

		for(TInt drive=0;drive<driveList.Length();drive++)
		{
			if(driveList[drive]!=0)
			{
				TBuf8<16> form;
				form.Format(_L8("%c:\\"),drive+65);
				form.ZeroTerminate();
				(*aDirEntList)[countedDrives] =(struct SymbianDirent*)  malloc(sizeof(struct SymbianDirent));
				strcpy((*aDirEntList)[countedDrives]->d_name, (char*) form.Ptr());
				(*aDirEntList)[countedDrives]->d_namlen = form.Length();
				(*aDirEntList)[countedDrives]->d_fileno = countedDrives;
				(*aDirEntList)[countedDrives]->d_reclen = 0;
				(*aDirEntList)[countedDrives]->d_type = DT_DIR;
				countedDrives++;				
			}			
		}	
		cnt = countedDrives;
	}
	else
	{
		CDir* entryList = NULL;
		if(path[path.Length()-1] != '\\' && path[path.Length()-1] != '/')
		{
			path.Append(_L("\\"));
		}

		TInt error  = CEikonEnv::Static()->FsSession().GetDir(path, 0xFFFF, ESortByName, entryList);
		if(error == KErrNone)
		{
			cnt = entryList->Count()+1;
			*aDirEntList = (struct SymbianDirent **) malloc(cnt*sizeof(struct SymbianDirent**));
		
			TBuf8<256> fname;
			for(TInt loop = 0;loop<cnt;loop++)
			{
				(*aDirEntList)[loop] =(struct SymbianDirent*)  malloc(sizeof(struct SymbianDirent));
				(*aDirEntList)[loop]->d_fileno = loop;

				if(loop == 0)
				{
					strcpy((*aDirEntList)[loop]->d_name, "..");
					(*aDirEntList)[loop]->d_type = DT_DIR;
					(*aDirEntList)[loop]->d_namlen = 2;
					(*aDirEntList)[loop]->d_reclen = 0;
				}
				else
				{					
					fname.Copy((*entryList)[loop-1].iName);
					fname.PtrZ();
					strcpy((*aDirEntList)[loop]->d_name, (char*) fname.Ptr());
					(*aDirEntList)[loop]->d_namlen = fname.Length();					
					(*aDirEntList)[loop]->d_reclen = (*entryList)[loop-1].iSize;
					(*aDirEntList)[loop]->d_type = (*entryList)[loop-1].IsDir()?DT_DIR:DT_REG;
				}
			}
		}
		else
		{
			cnt = error;
		}

		delete entryList;
	}
	return cnt;
}
void usleep(int aValue)
{
	User::AfterHighRes(aValue);
}


// apply the remapped button keystroke
extern int uae4all_keystate[256];
extern int keymappings[10][3];
void record_key (int kc);
int keycode2amiga(SDL_keysym *prKeySym);

int is_overridden_button(int button, int joy)
{
	// TODO: load from file
	int i;
	for (i = 0; i < 10; i++)
		{
		if(button == keymappings[i][0] && joy == keymappings[i][2])
			return 1;
		}
	
	return 0;
}

int get_key_for_button(int button, int joy)
{
	// TODO: load from file
	int i;
	for(i = 0;i<10;i++)
		{
		if(button == keymappings[i][0] && joy == keymappings[i][2])
			{
			SDL_keysym keysym;
			keysym.sym = (SDLKey) keymappings[i][1];
			return keycode2amiga(&keysym);
			}
		}
		return 0;
}


void handle_remapped_button_down(int button, int joy)
{
	int key = get_key_for_button(button, joy);
	if (!uae4all_keystate[key])
	{
		uae4all_keystate[key] = 1;
		record_key(key << 1);
	}
}

void handle_remapped_button_up(int button, int joy)
{
	int key = get_key_for_button(button, joy);

	if (uae4all_keystate[key])
	{
		uae4all_keystate[key] = 0;
		record_key((key << 1) | 1);
	}
}
//extern "C"
//	{
//
//#include "vsnprintf.h"
//	}
