/*
 * input.h
 *
 *  Created on: Aug 9, 2010
 *  
 *  Used for joystick/keyboard repeat delay/rate checks in menus and
 *  input mode changes. Not used for emulator key checks.
 */

#ifndef INPUT_H_
#define INPUT_H_

#include <SDL.h>

/* Keyboard/joystick *menu* parameters - repeat delay & rate */
#define KEY_JOY_REPEAT_DELAY	500	/* [ms] delay before repeat */
#define KEY_JOY_REPEAT_RATE		8	/* no. of repeats per second */

/* Used for comparing keyboar/joystick events - for repeat delay & rate */
enum {
	EKJ_LEFT = 1, EKJ_RIGHT, EKJ_UP, EKJ_DOWN,
	EKJ_HIT0, EKJ_HIT1, EKJ_HIT2, EKJ_HIT3, EKJ_HIT4, EKJ_HIT5,
	EKJ_HASH
};

/* Key/joystick repeat active ? */
extern bool gbKeyRepeatOn;

bool CheckKeyJoyRefresh (
		int aLeft, int aRight, int aUp, int aDown,
		int aHit0, int aHit1, int aHit2, int aHit3, int aHit4, int aHit5,
		int aKeyPressed);

#endif /* INPUT_H_ */
