#include<stdio.h>
#include<stdlib.h>
#include<SDL.h>
#include <sdl_image.h>

#include "gp2x.h"
#include "inputmode.h"

extern char launchDir [300];

extern SDL_Surface *prSDLScreen;

static SDL_Surface *ksur;
static SDL_Surface *inputMode[3];

extern int gp2xMouseEmuOn, gp2xButtonRemappingOn, show_inputmode;


#ifdef __SYMBIAN32__
char* DataPrefix();
#define IMAGEPATH DataPrefix()
#else
#define IMAGEPATH launchDir
#endif
void inputmode_init(void)
{
	int i;
	char tmpchar[256];
	SDL_Surface* tmp;

	sprintf(tmpchar, "%s/joystick.png", IMAGEPATH);
	tmp = IMG_Load(tmpchar);

	if (tmp)
	{
		inputMode[0] = SDL_DisplayFormat(tmp);
		SDL_FreeSurface(tmp);
	}
	
	sprintf(tmpchar, "%s/mouse.png", IMAGEPATH);
	tmp = IMG_Load(tmpchar);

	if (tmp)
	{
		inputMode[1] = SDL_DisplayFormat(tmp);
		SDL_FreeSurface(tmp);
	}

	sprintf(tmpchar, "%s/remapping.png", IMAGEPATH);
	tmp = IMG_Load(tmpchar);

	if (tmp)
	{
		inputMode[2] = SDL_DisplayFormat(tmp);
		SDL_FreeSurface(tmp);
	}

	show_inputmode = 0;
}


void inputmode_redraw(void)
{
	SDL_Rect r;
	SDL_Surface* surface = NULL;

	if (gp2xMouseEmuOn)
	{
		surface = inputMode[1];
	}
	else if (gp2xButtonRemappingOn)
	{
		surface = inputMode[2];
	}
	else
	{
		surface = inputMode[0];
	}

	if(surface != NULL)
	{
		r.x=(prSDLScreen->w/2)-surface->w/2;//80;
		r.y=(prSDLScreen->h/2)-(surface->h/2);
		r.w=surface->w;
		r.h=surface->h;
		
		SDL_BlitSurface(surface,NULL,prSDLScreen,&r);
	}
}

