#include<stdio.h>
#include<SDL.h>
#include "input.h"

extern SDL_Surface *prSDLScreen;
#ifdef __SYMBIAN32__
#define DATA_PREFIX
#define MENU_FILE_SPLASH DATA_PREFIX "splash.png"
#else
#define MENU_FILE_SPLASH DATA_PREFIX "gp2xsplash.png"
#endif
#define MENU_FILE_BACKGROUND DATA_PREFIX "background.png"
#define MENU_FILE_WINDOW DATA_PREFIX "window.png"
#define MENU_FILE_TEXT DATA_PREFIX "text.png"
#ifdef DREAMCAST
#define MENU_DIR_DEFAULT "/cd/"
#else
#define MENU_DIR_DEFAULT "."
#endif

void init_kickstart();
void showWarning(char *msg);

void text_draw_background();
void init_text(int splash);
void quit_text(void);
void write_text(int x, int y, char * str, int aMaxLen);
void write_text_inv(int x, int y, char * str, int aMaxLen);
void write_text(int x, int y, char * str);
void write_text_inv(int x, int y, char * str);
void write_text_norm(int x, int y, char * str);
void write_text_norm(int x, int y, char * str, int aMaxLen);
void write_centered_text(int y, char * str);
void write_num(int x, int y, int v);
void write_num_inv(int x, int y, int v);
void text_draw_window(int x, int y, int w, int h, char *title);
void _text_draw_window_bar(SDL_Surface *sf, int x, int y, int w, int h, int per, int max, char *title);
//void menuin_Effect();
//void menuout_Effect();
int save_thumb(int code,char *path);
int save_png(SDL_Surface* surface,char *path);

int createScript(int bIcon=0);

//int save_png(SDL_Surface* surface);
//void setupDrives(int num);
//void clearScreen();
//void fixDisplay();

// void text_draw_menu_msg();
void text_flip(void);
void set_joyConf(void);
void parse_cmdline(int argc, char **argv);
void loadconfig(int general=0);
int saveconfig(int general=0);

void drawPleaseWait(void);
void menu_raise(void);
void menu_unraise(void);

int run_mainMenu();
int run_menuLoad(char *, int aLoadtype);
int run_menuGame();
int run_menuSavestates();
int run_menuMisc();
int run_menuRemapping();
int run_menuMemDisk();
int run_menuControl();
enum { SCREENSHOT, ICON };

enum { MAIN_MENU_CASE_REBOOT, MAIN_MENU_CASE_LOAD, MAIN_MENU_CASE_RUN, MAIN_MENU_CASE_RESET, MAIN_MENU_CASE_CANCEL, MAIN_MENU_CASE_SAVESTATES, MAIN_MENU_CASE_EJECT, MAIN_MENU_CASE_MISC, MAIN_MENU_CASE_SAVE, MAIN_MENU_CASE_MEMDISK};
enum { MISC_MENU_CASE_MAIN, MISC_MENU_CASE_MEMDISK };
enum { MEMDISK_MENU_CASE_MAIN, MEMDISK_MENU_CASE_MISC };

/* Just 0x0 and not 680x0, so that constants can fit in ARM instructions */
#define M68000 000
#define M68020 020

#define DEFAULT_STATUSLN 0
#define DEFAULT_MOUSEMULTIPLIER 1
#define DEFAULT_SOUND 1
#define DEFAULT_AUTOSAVE 1
#define DEFAULT_SYSTEMCLOCK 0
#define DEFAULT_SYNCTHRESHOLD 2
#define DEFAULT_SKIPINTRO 0

#define DEFAULT_NTSC 0
#define DEFAULT_JOYCONF 0
#define DEFAULT_CHIPMEM_SELECT 1
#define DEFAULT_ENABLE_HD 0
#define DEFAULT_AUTOFIRE 0
#define DEFAULT_DRIVES 2
#define DEFAULT_ENABLESCRIPTS 0
#define DEFAULT_ENABLESCREENSHOTS 0
#define DEFAULT_SCALING 0
#define DEFAULT_KICKSTART 1
#define DEFAULT_KEYPAD 0
#define DEFAULT_CPU_MODEL M68000


#define MENU_MAIN_WINDOW_WIDTH 34
#define MENU_MISC_WINDOW_WIDTH 40
#define MENU_MEMDISK_WINDOW_WIDTH 40

#define MAX_MOVE_X 64
#define MAX_MOVE_Y 32

/* Event intervals */
#define SELECTION_DRAWING_INTERVAL	250	/* [ms] inverted/normal text */
#define EVENT_POLLING_INTERVAL		50	/* [ms] SDL events polling */

/* What is being loaded */
#define MENU_LOAD_FLOPPY 1
#define MENU_LOAD_HD_DIR 2
#define MENU_LOAD_HDF 3

/* All the menus + default(NONE) */
enum { EMENU_NONE = 0, EMENU_MAIN, EMENU_LOAD, EMENU_MISC, EMENU_FILEINFO, EMENU_MEMDISK, EMENU_REMAPPING };

/* Active menu window - used for refreshing the whole window when menu changes */
extern int gActiveMenu;
extern int gActiveMenu_last;


/* Checks if drawing interval has passed, and if menu window should
 *  be refreshed.
 */
bool CheckMenuRefresh (
		int aMenuID,
		int aSelectionID,
		int aSelectionID_last,
		bool *aInverted_text,
		bool *aInitialized);

