#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include <SDL.h>


//#include <SDL_gp2x.h>
#include "gp2xutil.h"
#include "menu.h"
#include "sysconfig.h"
#include "sysdeps.h"
#include "autoconf.h"
#include "vkbd.h"
#include "options.h"
#include "sound.h"
#include "zfile.h"
#include "gp2x.h"
#include "disk.h"
#include "volumecontrol.h"
static int norelaunchGP2XMenu = 0;
#include "menu_load.h"
//#include "gp2xutil.h"
#include "cpuspeed/cpuctrl.h"
#include "custom.h"

/* PocketUAE config file. Used for parsing PocketUAE-like options. */
#include "cfgfile.h"
#include "savestate.h"

extern void moveHorizontal(int value);
extern void moveVertical(int value);

extern int text_dir_num_files_index;
int init_sound(void);
void gp2x_stop_sound(void);
extern char launchDir[300];
extern char currentDir[300];

extern int emulating;
extern void setBatteryLED(int);
extern int flashLED;
extern int gp2xClockSpeed;
extern unsigned int sound_rate;
extern int timeslice_mode;
extern int skipintro;
extern char launchDir[300];
extern int bReloadKickstart;
extern int soundVolume;

char *statusmessages[] = { "AUTOFIRE ON\0", "AUTOFIRE OFF\0","SCREENSHOT SAVED\0","SCRIPT SAVED\0","SCRIPT AND SCREENSHOT SAVED\0"};
int showmsg=0;

extern char uae4all_image_file0[128];
extern char uae4all_image_file1[128];
extern char uae4all_image_file2[128];
extern char uae4all_image_file3[128];

extern char uae4all_hard_dir[128];
extern char uae4all_hard_file[128];

static char *text_str_title=    "-- UAE4ALL v0.9 (1-3 Menu)--";
static char *text_str_load=     "Select Image Disk (L)";
static char *text_str_throttle= "CPU Emulation Speed";//System clock
static char *text_str_sync_trsh="CPU Vs Chipset";//Sync threshold
#ifdef CYCLONE
static char *text_str_cpu_clock="++++ Cyclone version ++++";
#else
static char *text_str_cpu_clock="Savestates";
#endif
static char *text_str_frameskip="Frameskip";
static char *text_str_0="0";
static char *text_str_1="1";
static char *text_str_2="2";
static char *text_str_3="3";
static char *text_str_4="4";
static char *text_str_5="5";
static char *text_str_mouse_multiplier="Mouse speed";
static char *text_str_1x="1x";
static char *text_str_2x="2x";
static char *text_str_3x="3x";
static char *text_str_4x="4x";
static char *text_str_5x="5x";
static char *text_str_44k="44k";
static char *text_str_32k="32k";
static char *text_str_22k="22k";
static char *text_str_11k="11k";
static char *text_str_8k="8k";
static char *text_str_100p="100";
static char *text_str_83p="83";
static char *text_str_75p="75";
static char *text_str_50p="50";
static char *text_str_25p="25";
static char *text_str_auto="auto";
static char *text_str_eject="Eject All Drives(X)";
//static char *text_str_gp2x_clock="Clock MHz";
#ifndef __SYMBIAN32__
static char *text_str_gp2x_clock_none="none";
static char *text_str_gp2x_clock_200="200";
static char *text_str_gp2x_clock_250="250";
static char *text_str_gp2x_clock_275="275";
#endif
static char *text_str_sound="Sound";
static char *text_str_on="on";
static char *text_str_off="off";
static char *text_str_faked="faked";
static char *text_str_approx="approx";
static char *text_str_separator="--------------------------------";
static char *text_str_reset="Reset  R";
static char *text_str_run=  "Run (Start)";
static char *text_str_exit= "Exit";
static char *text_str_sndrate="Sound rate";
static char *text_str_volume="Volume";

int mainMenu_throttle=0;

#if !defined(DEBUG_UAE4ALL) && !defined(PROFILER_UAE4ALL) && !defined(AUTO_RUN) && !defined(AUTO_FRAMERATE)
int mainMenu_frameskip=-1;
#else
#ifdef PROFILER_UAE4ALL
#ifndef AUTO_PROFILER
int mainMenu_frameskip=0;
#else
int mainMenu_frameskip=-1;
#endif
#else
#ifdef DEBUG_FRAMERATE
int mainMenu_frameskip=-1;
#else
int mainMenu_frameskip=0;
#endif
#endif
#endif
int def_frameskip=mainMenu_frameskip;
#define DEFAULT_FRAMESKIP def_frameskip

int mainMenu_showStatus=DEFAULT_STATUSLN;
int mainMenu_mouseMultiplier = DEFAULT_MOUSEMULTIPLIER;
int mainMenu_sound=DEFAULT_SOUND;
int mainMenu_case=-1;
int mainMenu_autosave=DEFAULT_AUTOSAVE;
int mainMenu_ntsc=DEFAULT_NTSC;
int mainMenu_CPU_model=DEFAULT_CPU_MODEL;
int mainMenu_chipset=DEFAULT_CHIPSET_SELECT;
int mainMenu_moveX=0;
int mainMenu_moveY=0;
int mainMenu_chipMemory=DEFAULT_CHIPMEM_SELECT;
int mainMenu_slowMemory=0;	/* off */
int mainMenu_fastMemory=0;	/* off */
int mainMenu_bootHD=DEFAULT_ENABLE_HD;
int mainMenu_joyConf=DEFAULT_JOYCONF;
int mainMenu_button1=GP2X_BUTTON_B;
int mainMenu_button2=GP2X_BUTTON_X;
int mainMenu_jump=0;
int mainMenu_autofire=DEFAULT_AUTOFIRE;
int mainMenu_drives=DEFAULT_DRIVES;

int mainMenu_filesysUnits=0;
int hd_dir_unit_nr=-1;
int hd_file_unit_nr=-1;

extern int enableHWscaling;
extern int gp2xMouseEmuOn;
extern int gp2xButtonRemappingOn;
extern SDL_Joystick *uae4all_joy0;
int mainMenu_enableScreenshots=DEFAULT_ENABLESCREENSHOTS;
int mainMenu_enableScripts=DEFAULT_ENABLESCRIPTS;
int mainMenu_keypadConf=DEFAULT_KEYPAD;
int nr_drives=DEFAULT_DRIVES;
extern int kickstart;
extern int oldkickstart;

static void reload_kickstart() {
	if (kickstart!=oldkickstart) 
	{
		oldkickstart=kickstart;
		sprintf(romfile,"%s/kickstarts/%s",launchDir,kickstarts_rom_names[kickstart]);
		init_kickstart();
	}
}

static void reset_hdConf() {
	/* Reset HD config */
	if (hd_dir_unit_nr >= 0) {
		kill_filesys_unit(currprefs.mountinfo, 0);
		mainMenu_filesysUnits--;
		hd_dir_unit_nr = -1;
	}
	if (hd_file_unit_nr >= 0) {
		kill_filesys_unit(currprefs.mountinfo, 0);
		mainMenu_filesysUnits--;
		hd_file_unit_nr = -1;
	}

	switch (mainMenu_bootHD) {
		case 0:
			// nothing to do, already killed above
			break;
		case 1:
			if (hd_dir_unit_nr < 0) {
				if (uae4all_hard_dir[0] != '\0') {
					parse_filesys_spec(0, uae4all_hard_dir);
					hd_dir_unit_nr = mainMenu_filesysUnits++;
				}
			}
			if (hd_file_unit_nr < 0) {
				if (uae4all_hard_file[0] != '\0') {
					parse_hardfile_spec(uae4all_hard_file);
					hd_file_unit_nr = mainMenu_filesysUnits++;
				}
			}
			break;
		case 2:
			if (hd_file_unit_nr < 0) {
				if (uae4all_hard_file[0] != '\0') {
					parse_hardfile_spec(uae4all_hard_file);
					hd_file_unit_nr = mainMenu_filesysUnits++;
				}
			}
			if (hd_dir_unit_nr < 0) {
				if (uae4all_hard_dir[0] != '\0') {
					parse_filesys_spec(0, uae4all_hard_dir);
					hd_dir_unit_nr = mainMenu_filesysUnits++;
				}
			}
			break;
	}
}

/*
0 = load
1 = throttle
2 = sync threshold
3 = frameskip
//4 = cpu speed
5 = mouse cursor speed
6 = sound
7 = eject external drives
8 = sound rate
9 = misc
10 = reset
11 = run
12 = save config current game
13 = save script current game
14 = save general config
15 = exit
*/
enum Menu_Main 
	{
	MAIN_LOAD = 1,
	MAIN_THROTTLE,
	MAIN_SYNC,
	MAIN_FRAMESKIP,
	MAIN_CPUSPEED,
	MAIN_MOUSESPEED,
	MAIN_SOUND,
	MAIN_EJECTALL,
	MAIN_SOUNDRATE,
	MAIN_MISC,
	MAIN_RESET,
	MAIN_RUN,
	MAIN_SAVEGAMECONFIG,
	MAIN_SAVEGAMESCRIPT,
	MAIN_SAVEGENERALCONFIG,
	MAIN_SAVESTATES,
	MAIN_EXIT,
	MAIN_SEPARATOR,
	MAIN_SOUNDVOLUME
	};

const char main_menu[] = 
		{
		MAIN_LOAD,
		MAIN_RUN,
		MAIN_RESET,
		MAIN_EJECTALL,
		MAIN_SEPARATOR,
		MAIN_THROTTLE,
		MAIN_SYNC,
		MAIN_FRAMESKIP,
		MAIN_MOUSESPEED,
		MAIN_SOUND,
		MAIN_SOUNDRATE,
		MAIN_SOUNDVOLUME,		
		MAIN_MISC,
		MAIN_SEPARATOR,
		MAIN_SAVEGAMECONFIG,
		MAIN_SAVEGENERALCONFIG,		
		MAIN_EXIT
		,0		
		};

int createScript(int bIcon)
{
	if(!uae4all_image_file0[0]) return 0;
	char path[512];
	char script[512];
	char buffer[128];
	char *p; 
	if (!strlen(uae4all_image_file0)) return 0;
	p=uae4all_image_file0+strlen(uae4all_image_file0)-1;
	while (*p != '/' && *p != '\\')p--;
	p++;
	int len=strlen(p);
	char gamename[256];
	strcpy(gamename,p);
	char * pch;
	pch = strstr (gamename,"(");
	if (pch) strcpy(pch,"\0");
	else{
		pch = strstr (gamename,".adf");
		if (pch) strcpy(pch,"\0");
	}
	if (uae4all_image_file0[0])	sprintf(path, "%s/scripts/%s.gpe", launchDir,gamename);
	else return 0;
	FILE *f=fopen(path,"w");
	if (!f) return 0;
	strcpy(script,"#!/bin/sh\n");
	strcat(script,"./cpu_speed --upll --timing 1 --cpuclk 266 --trc 6 --tras 4 --twr 1 --tmrd 1 --trfc 1 --trp 2 --trcd 2\n");
	strcat(script,"sleep 1\n");
	
	strcat(script,"cd ..\n");
	strcat(script,"./uae4all.gpe ");
	sprintf(buffer,"-df0 \"%s\" ",uae4all_image_file0);
	strcat(script,buffer);
	
	if(uae4all_image_file1[0]){
		sprintf(buffer,"-df1 \"%s\" ",uae4all_image_file1);
		strcat(script,buffer);
	}
	
	if(uae4all_image_file2[0]){
		sprintf(buffer,"-df2 \"%s\" ",uae4all_image_file2);
		strcat(script,buffer);
	}
	
	if(uae4all_image_file3[0]){
		sprintf(buffer,"-df3 \"%s\" ",uae4all_image_file3);
		strcat(script,buffer);
	}
	

	if (mainMenu_mouseMultiplier!=DEFAULT_MOUSEMULTIPLIER) {
		sprintf(buffer,"-mousemultiplier %d ",mainMenu_mouseMultiplier);
		strcat(script,buffer);
	}

	
	if (mainMenu_sound!=DEFAULT_SOUND) {
		sprintf(buffer,"-sound %d ",mainMenu_sound);
		strcat(script,buffer);
	}

	if (sound_rate!=DEFAULT_SOUND_FREQ) {
		sprintf(buffer,"-soundrate %d ",sound_rate);
		strcat(script,buffer);
	}
	if (mainMenu_throttle!=DEFAULT_SYSTEMCLOCK) { 
		sprintf(buffer,"-systemclock %d ",mainMenu_throttle);
		strcat(script,buffer);
	}

	if (timeslice_mode!=DEFAULT_SYNCTHRESHOLD) {
		sprintf(buffer,"-syncthreshold %d ",timeslice_mode);
		strcat(script,buffer);
	}

	if (mainMenu_autosave!=DEFAULT_AUTOSAVE){
		sprintf(path,"-autosave %d ",mainMenu_autosave);
		strcat(script,buffer);
	}

	if (mainMenu_frameskip!=DEFAULT_FRAMESKIP) {
		sprintf(buffer,"-frameskip %d ",mainMenu_frameskip);
		strcat(script,buffer);
	}

	if (mainMenu_joyConf!=DEFAULT_JOYCONF) {
		sprintf(buffer,"-joyconf %d ",mainMenu_joyConf);
		strcat(script,buffer);
	}

	if (mainMenu_ntsc!=DEFAULT_FRAMESKIP) {
		sprintf(buffer,"-ntsc %d ",mainMenu_ntsc);
		strcat(script,buffer);
	}

	if (mainMenu_drives!=DEFAULT_DRIVES) {
		sprintf(path,"-drives %d ",mainMenu_drives);
		strcat(script,buffer);
	}
	
	if (mainMenu_autofire!=DEFAULT_AUTOFIRE) {
		sprintf(buffer,"-autofire %d ",mainMenu_autofire);
		strcat(script,buffer);
	}
	
	if (mainMenu_chipMemory!=DEFAULT_CHIPMEM_SELECT) {
		sprintf(buffer,"-use1mbchip %d ",mainMenu_chipMemory);
		strcat(script,buffer);
	}

	if (enableHWscaling!=DEFAULT_SCALING) {
		sprintf(buffer,"-scaling %d ",enableHWscaling);
		strcat(script,buffer);
	}

	if (kickstart!=DEFAULT_KICKSTART) {
		sprintf(buffer,"-kickstart %d ",kickstart);
		strcat(script,buffer);
	}

	strcat(script,"\n\0");
	
	fputs(script,f);
	fclose(f);
	sprintf(path, "%s/scripts/%s.png", launchDir,gamename);
	if (bIcon) save_thumb(ICON,path);
	return 1;
	
}
static void extractFileName(char * str,char *buffer)
{
	char *p=str+strlen(str)-1;
	while(*p != '/' && *p != '\\') p--;
	p++;
	strcpy(buffer,p);
}

static void adjustToWindow(char *str, char* buffer)
{
	if (strlen(str)<33) 
	{
		strcpy(buffer, str);
		return;
	}
	char *p=str+strlen(str)-13;
	for (int i=0;i<15;i++) {buffer[i]=*str;str++;}
	char tt[]={'.','.','.','\0',};
	//char *pp=&tt;
	strcat(buffer,tt);
	strcat(buffer,p);
}
static void showInfo()

{
	text_draw_background();
	char buffer[128];
	char buffertext[128];

	text_draw_window(2,2,35,20,"Info");
	SDL_Rect r;
	r.x=80-64; r.y=0; r.w=35*7; r.h=140;
	extern SDL_Surface *text_screen;
	SDL_SetClipRect(text_screen,&r);
	write_text(4,4,"Df0");

	if (!uae4all_image_file0[0]) write_text(10,4,"Empty");
	else 
	{
		extractFileName(uae4all_image_file0,buffer);
		adjustToWindow(buffer,buffertext);
		write_text(10,4,buffertext);
	}

	write_text(4,6,"Df1");
	if (!uae4all_image_file1[0]) write_text(10,6,"Empty");
	else 
	{
		extractFileName(uae4all_image_file1,buffer);
		adjustToWindow(buffer,buffertext);
		write_text(10,6,buffertext);
	}
	
	write_text(4,8,"Df2");
	if (!uae4all_image_file2[0]) write_text(10,8,"Empty");
	else 
	{
		extractFileName(uae4all_image_file2,buffer);
		adjustToWindow(buffer,buffertext);
		write_text(10,8,buffertext);
	}
	
	write_text(4,10,"Df3");
	if (!uae4all_image_file3[0]) write_text(10,10,"Empty");
	else 
	{
		extractFileName(uae4all_image_file3,buffer);
		adjustToWindow(buffer,buffertext);
		write_text(10,10,buffertext);
	}

		text_flip();
		SDL_Event ev;
		SDL_Delay(333);
		while(SDL_PollEvent(&ev))
		SDL_Delay(10);
		while(!SDL_PollEvent(&ev))
				SDL_Delay(10);
		while(SDL_PollEvent(&ev))
				if (ev.type==SDL_QUIT)
					exit(1);
		SDL_Delay(200);
		SDL_SetClipRect(text_screen,NULL);
}

void set_joyConf()
{
	if (mainMenu_joyConf==0)
	{
		mainMenu_button1=GP2X_BUTTON_B;
		mainMenu_button2=GP2X_BUTTON_X;
		mainMenu_jump=0;
	}
	else if(mainMenu_joyConf==1)
	{
		mainMenu_button1=GP2X_BUTTON_B;
		mainMenu_button2=GP2X_BUTTON_A;
		mainMenu_jump=GP2X_BUTTON_X;
	}
	
	else if(mainMenu_joyConf==2)
	{
		mainMenu_button1=GP2X_BUTTON_X;
		mainMenu_button2=GP2X_BUTTON_A;
		mainMenu_jump=GP2X_BUTTON_B;
	}
}


static void draw_mainMenu(int c)
{
	/*
	0 = load
	1 = throttle
	2 = sync threshold
	3 = frameskip
	//4 = cpu speed
	5 = mouse cursor speed
	6 = sound
	7 = eject external drives
	8 = sound rate
	9 = misc
	10 = reset
	11 = run
	12 = save config current game
	13 = save script current game
	14 = save general config
	15 = exit
	*/
	static bool bb = false;		/* Inverted/normal selection drawing */
	static int c_last;			/* Last selection */
	static bool bInitialized;	/* Window is drawn only once, except when menu changes */
	int menuItem = 0;

	int menuLine = 3;
	int leftMargin = 8;
	int tabstop1 = 17+4;
	int tabstop2 = 19+4;
	int tabstop3 = 21+4;
	int tabstop4 = 23+4;
	int tabstop5 = 25+4;
	int tabstop6 = 27+4;
	int tabstop7 = 29+4;
	int tabstop8 = 31+4;
	int tabstop9 = 33+4;
	
	/* Should menu window be refreshed ? */  
	if (!CheckMenuRefresh(EMENU_MAIN, c, c_last, &bb, &bInitialized))
		return;
	
	if (!bInitialized) {
		text_draw_background();
		text_draw_window(leftMargin-1,menuLine-1,MENU_MAIN_WINDOW_WIDTH,35,text_str_title);
	}
	
	while(main_menu[menuItem] != 0)
	{
		if (main_menu[menuItem]==MAIN_SEPARATOR)
		{
			menuLine--;
			write_text(leftMargin,menuLine,text_str_separator);
		} else if (menuItem > 0) {
			if (main_menu[menuItem-1]==MAIN_SEPARATOR)
				menuLine--;
		}
		
		if ((c==menuItem)||(c_last==menuItem)||!bInitialized ) {
			switch(main_menu[menuItem])
			{
				case MAIN_LOAD: {
					if ((main_menu[c]==MAIN_LOAD)&&(bb))
						write_text_inv(leftMargin,menuLine,text_str_load);
					else
						write_text_norm(leftMargin,menuLine,text_str_load);
				}break;
				
				case MAIN_THROTTLE: {
					if (!bInitialized) write_text(leftMargin,menuLine,text_str_throttle);
					
					if ((mainMenu_throttle==0)&&((main_menu[c]!=MAIN_THROTTLE)||(!bb)))
						write_text_inv(tabstop5,menuLine,text_str_100p);
					else
						write_text_norm(tabstop5,menuLine,text_str_100p);
					
					if ((mainMenu_throttle==2)&&((main_menu[c]!=MAIN_THROTTLE)||(!bb)))
						write_text_inv(tabstop7,menuLine,text_str_83p);
					else
						write_text_norm(tabstop7,menuLine,text_str_83p);
					
					if ((mainMenu_throttle==4)&&((main_menu[c]!=MAIN_THROTTLE)||(!bb)))
						write_text_inv(tabstop9,menuLine,text_str_75p);
					else
						write_text_norm(tabstop9,menuLine,text_str_75p);
				}break;
				
				case MAIN_SYNC: {
					if (!bInitialized) write_text(leftMargin,menuLine,text_str_sync_trsh);
					
					if ((timeslice_mode==0)&&((main_menu[c]!=MAIN_SYNC)||(!bb)))
						write_text_inv(tabstop3,menuLine,text_str_100p);
					else
						write_text_norm(tabstop3,menuLine,text_str_100p);
					
					if ((timeslice_mode==1)&&((main_menu[c]!=MAIN_SYNC)||(!bb)))
						write_text_inv(tabstop5,menuLine,text_str_75p);
					else
						write_text_norm(tabstop5,menuLine,text_str_75p);
					
					if ((timeslice_mode==2)&&((main_menu[c]!=MAIN_SYNC)||(!bb)))
						write_text_inv(tabstop7,menuLine,text_str_50p);
					else
						write_text_norm(tabstop7,menuLine,text_str_50p);
					
					if ((timeslice_mode==3)&&((main_menu[c]!=MAIN_SYNC)||(!bb)))
						write_text_inv(tabstop9,menuLine,text_str_25p);
					else
						write_text_norm(tabstop9,menuLine,text_str_25p);
				}break;
				
				case MAIN_FRAMESKIP: {
					if (!bInitialized) write_text(leftMargin,menuLine,text_str_frameskip);
					
					if ((mainMenu_frameskip==0)&&((main_menu[c]!=MAIN_FRAMESKIP)||(!bb)))
						write_text_inv(tabstop1,menuLine,text_str_0);
					else
						write_text_norm(tabstop1,menuLine,text_str_0);
					if ((mainMenu_frameskip==1)&&((main_menu[c]!=MAIN_FRAMESKIP)||(!bb)))
						write_text_inv(tabstop2,menuLine,text_str_1);
					else
						write_text_norm(tabstop2,menuLine,text_str_1);
					if ((mainMenu_frameskip==2)&&((main_menu[c]!=MAIN_FRAMESKIP)||(!bb)))
						write_text_inv(tabstop3,menuLine,text_str_2);
					else
						write_text_norm(tabstop3,menuLine,text_str_2);
					if ((mainMenu_frameskip==3)&&((main_menu[c]!=MAIN_FRAMESKIP)||(!bb)))
						write_text_inv(tabstop4,menuLine,text_str_3);
					else
						write_text_norm(tabstop4,menuLine,text_str_3);
					if ((mainMenu_frameskip==4)&&((main_menu[c]!=MAIN_FRAMESKIP)||(!bb)))
						write_text_inv(tabstop5,menuLine,text_str_4);
					else
						write_text_norm(tabstop5,menuLine,text_str_4);
					if ((mainMenu_frameskip==5)&&((main_menu[c]!=MAIN_FRAMESKIP)||(!bb)))
						write_text_inv(tabstop6,menuLine,text_str_5);
					else
						write_text_norm(tabstop6,menuLine,text_str_5);
					if ((mainMenu_frameskip==-1)&&((main_menu[c]!=MAIN_FRAMESKIP)||(!bb)))
						write_text_inv(tabstop7,menuLine,text_str_auto);
					else
						write_text_norm(tabstop7,menuLine,text_str_auto);
				}break;
				
				case MAIN_CPUSPEED: {
					if ((main_menu[c]==MAIN_CPUSPEED)&&(bb))
						write_text_inv(leftMargin,menuLine,text_str_cpu_clock);
					else
						write_text_norm(leftMargin,menuLine,text_str_cpu_clock);
				}break;
				
				case MAIN_MOUSESPEED: {
					if (!bInitialized) write_text(leftMargin,menuLine,text_str_mouse_multiplier);
					
					if ((mainMenu_mouseMultiplier==1)&&((main_menu[c]!=MAIN_MOUSESPEED)||(!bb)))
						write_text_inv(tabstop1,menuLine,text_str_1x);
					else
						write_text_norm(tabstop1,menuLine,text_str_1x);
					if ((mainMenu_mouseMultiplier==2)&&((main_menu[c]!=MAIN_MOUSESPEED)||(!bb)))
						write_text_inv(tabstop3,menuLine,text_str_2x);
					else
						write_text_norm(tabstop3,menuLine,text_str_2x);
					if ((mainMenu_mouseMultiplier==3)&&((main_menu[c]!=MAIN_MOUSESPEED)||(!bb)))
						write_text_inv(tabstop5,menuLine,text_str_3x);
					else
						write_text_norm(tabstop5,menuLine,text_str_3x);
					if ((mainMenu_mouseMultiplier==4)&&((main_menu[c]!=MAIN_MOUSESPEED)||(!bb)))
						write_text_inv(tabstop7,menuLine,text_str_4x);
					else
						write_text_norm(tabstop7,menuLine,text_str_4x);
					if ((mainMenu_mouseMultiplier==5)&&((main_menu[c]!=MAIN_MOUSESPEED)||(!bb)))
						write_text_inv(tabstop9,menuLine,text_str_5x);
					else
						write_text_norm(tabstop9,menuLine,text_str_5x);
				}break;
				
				case MAIN_SOUND: {
					if (!bInitialized) write_text(leftMargin,menuLine,text_str_sound);
					
					if ((mainMenu_sound==0)&&((main_menu[c]!=MAIN_SOUND)||(!bb)))
						write_text_inv(tabstop1,menuLine,text_str_off);
					else
						write_text_norm(tabstop1,menuLine,text_str_off);
					if ((mainMenu_sound==1)&&((main_menu[c]!=MAIN_SOUND)||(!bb)))
						write_text_inv(tabstop3,menuLine,text_str_on);
					else
						write_text_norm(tabstop3,menuLine,text_str_on);
					if ((mainMenu_sound==2)&&((main_menu[c]!=MAIN_SOUND)||(!bb)))
						write_text_inv(tabstop5-1,menuLine,text_str_faked);
					else
						write_text_norm(tabstop5-1,menuLine,text_str_faked);
					if ((mainMenu_sound==3)&&((main_menu[c]!=MAIN_SOUND)||(!bb)))
						write_text_inv(tabstop7+1,menuLine,text_str_approx);
					else
						write_text_norm(tabstop7+1,menuLine,text_str_approx);
				}break;
				
				case MAIN_SOUNDVOLUME: {
					char soundvolumestr[40];
					int soundSize = soundVolume;
					
					if (!bInitialized) write_text_norm(leftMargin,menuLine,"Volume");
					
					strcpy(soundvolumestr, "<");
					while(soundSize>0) {
						strcat(soundvolumestr,"\xDB");
						soundSize-=10;
					}
					strcat(soundvolumestr, ">");
					if ((main_menu[c]==MAIN_SOUNDVOLUME)&&(bb))				
						write_text_inv(tabstop3,menuLine,soundvolumestr, 12);
					else
						write_text_norm(tabstop3,menuLine,soundvolumestr, 12);
				}break;
				
				case MAIN_EJECTALL: {
					if ((main_menu[c]==MAIN_EJECTALL)&&(bb))
						write_text_inv(leftMargin,menuLine,text_str_eject);
					else
						write_text_norm(leftMargin, menuLine,text_str_eject);
				}break;
				
				case MAIN_SOUNDRATE: {
					if (!bInitialized) write_text(leftMargin,menuLine,text_str_sndrate);
					
					if ((sound_rate==8000)&&((main_menu[c]!=MAIN_SOUNDRATE)||(!bb)))
						write_text_inv(tabstop1,menuLine,text_str_8k);
					else
						write_text_norm(tabstop1,menuLine,text_str_8k);
					
					if ((sound_rate==11025)&&((main_menu[c]!=MAIN_SOUNDRATE)||(!bb)))
						write_text_inv(tabstop3,menuLine,text_str_11k);
					else
						write_text_norm(tabstop3,menuLine,text_str_11k);
					
					if ((sound_rate==22050)&&((main_menu[c]!=MAIN_SOUNDRATE)||(!bb)))
						write_text_inv(tabstop5,menuLine,text_str_22k);
					else
						write_text_norm(tabstop5,menuLine,text_str_22k);
					
					if ((sound_rate==32000)&&((main_menu[c]!=MAIN_SOUNDRATE)||(!bb)))
						write_text_inv(tabstop7,menuLine,text_str_32k);
					else
						write_text_norm(tabstop7,menuLine,text_str_32k);
					
					if ((sound_rate==44100)&&((main_menu[c]!=MAIN_SOUNDRATE)||(!bb)))
						write_text_inv(tabstop9,menuLine,text_str_44k);
					else
						write_text_norm(tabstop9,menuLine,text_str_44k);
				}break;
				
				case MAIN_MISC: {
					if ((main_menu[c]==MAIN_MISC)&&(bb))
						write_text_inv(leftMargin,menuLine,"More Options");
					else
						write_text_norm(leftMargin,menuLine,"More Options");
				}break;
				
				case MAIN_RESET: {
					if ((main_menu[c]==MAIN_RESET)&&(bb))
						write_text_inv(leftMargin,menuLine,text_str_reset);
					else
						write_text_norm(leftMargin,menuLine,text_str_reset);
				}break;
				
				case MAIN_RUN: {
					if ((main_menu[c]==MAIN_RUN)&&(bb))
						write_text_inv(leftMargin,menuLine,text_str_run);
					else
						write_text_norm(leftMargin,menuLine,text_str_run);
				}break;
				
				case MAIN_SAVEGAMECONFIG: {
					if ((main_menu[c]==MAIN_SAVEGAMECONFIG)&&(bb))
						write_text_inv(leftMargin,menuLine,"Save Config for current game");
					else
						write_text_norm(leftMargin,menuLine,"Save Config for current game");
				}break;
				
				case MAIN_SAVEGAMESCRIPT: {
					if ((main_menu[c]==MAIN_SAVEGAMESCRIPT)&&(bb))
						write_text_inv(leftMargin,menuLine,"Save Script for current game");
					else
						write_text_norm(leftMargin,menuLine,"Save Script for current game");
				}break;
				
				case MAIN_SAVEGENERALCONFIG: {
					if ((main_menu[c]==MAIN_SAVEGENERALCONFIG)&&(bb))
						write_text_inv(leftMargin,menuLine,"Save General Config");
					else
						write_text_norm(leftMargin,menuLine,"Save General Config");
				}break;
				
				case MAIN_EXIT: {
					if ((main_menu[c]==MAIN_EXIT)&&(bb))
						write_text_inv(leftMargin,menuLine,text_str_exit);
					else
						write_text_norm(leftMargin,menuLine,text_str_exit);
				}break;	
			}
		}
		menuLine+=2;
		menuItem++;
	}
	
	text_flip();
	
	/* Last active option */
	c_last = c;
	
	/* Window has been completely drawn */
	bInitialized = true;
}



void showWarning(char *msg)
{
	text_draw_window(54/7,91/8,255/7,64/8,"--- Config ---");
	write_text(12,14,msg);
	write_text(11,16,"Press any button to continue");
	text_flip();
	SDL_Event ev;
	SDL_Delay(333);
	while(SDL_PollEvent(&ev))
		SDL_Delay(10);
	while(!SDL_PollEvent(&ev))
		SDL_Delay(10);
	while(SDL_PollEvent(&ev))
		if (ev.type==SDL_QUIT)
			exit(1);
	SDL_Delay(200);
	
	/* Invalidate/redraw menu window */
	gActiveMenu_last = EMENU_NONE;
}

void update_joystick(int& left, int& right, int& up, int& down);

static int key_mainMenu(int *cp)
{
	int back_c = -1;
	int c=(*cp);
	int end=0;
	int left=0, right=0, up=0, down=0, hit0=0, hit1=0, hit2=0, hit3=0, hit4=0, hit5=0;
	SDL_Event event;
	int info=0;
	SDL_Joystick *joy = uae4all_joy0 ;
	
#ifndef __SYMBIAN32__
	SDL_JoystickUpdate ();
#endif
	
#ifndef __SYMBIAN32__
	if (SDL_JoystickGetButton(joy, GP2X_BUTTON_RIGHT)) right=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_LEFT)) left=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_UP)) up=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_DOWN)) down=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_B)) hit0=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_START)) hit1=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_L)) hit3=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_R)) hit4=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_X)) hit5=1;
#endif
	while (SDL_PollEvent(&event) > 0)
	{				
		if (event.type == SDL_QUIT)
		{
			mainMenu_case=MAIN_MENU_CASE_REBOOT;
			end=-1;
		}
		else if (event.type == SDL_JOYBUTTONDOWN)
		{
			switch (event.jbutton.button)
			{
#ifdef __SYMBIAN32__
				case 0:hit0=1; break;
				case 1:info=1;/*hit3=1;*/break;
				case 2:hit3=1;/*info=1;*/break;
#else				
				case GP2X_BUTTON_RIGHT: right=1; break;
				case GP2X_BUTTON_LEFT: left=1; break;
				case GP2X_BUTTON_UP: up=1; break;
				case GP2X_BUTTON_DOWN: down=1; break;
				case GP2X_BUTTON_B: hit0=1; break;
				case GP2X_BUTTON_START: hit1=1; break;
				case GP2X_BUTTON_L: hit3=1; break;
				case GP2X_BUTTON_R: hit4=1; break;
				case GP2X_BUTTON_X: hit5=1; break;
#endif
				//	case GP2X_BUTTON_SELECT: info=1; break;
			}
		}
		else
			if (event.type == SDL_KEYDOWN)
			{
				uae4all_play_click();
				switch(event.key.keysym.sym)
				{
					case SDLK_RIGHT: right=1; break;
					case SDLK_LEFT: left=1; break;
					case SDLK_UP: up=1; break;
					case SDLK_DOWN: down=1; break;
					case SDLK_RETURN:
					case SDLK_LCTRL: hit0=1; break;
					case SDLK_BACKSPACE:
					case SDLK_ESCAPE:
					case SDLK_LALT: hit1=1; break;
					case SDLK_SPACE: info=1; break;
					case SDLK_0:
					case SDLK_PERIOD: hit3=1; break;
					case SDLK_1: break;
					case SDLK_2: mainMenu_case=MAIN_MENU_CASE_MISC; end = EMENU_MISC; break;
					case SDLK_3: mainMenu_case=MAIN_MENU_CASE_MEMDISK; end = EMENU_MEMDISK; break;
					default:
						break;
				}
			}
	}
	
#ifdef __SYMBIAN32__
	update_joystick(left, right, up, down);
#endif
	
	/* Interval for checking key/joy events */
	if (!CheckKeyJoyRefresh(
			left, right, up, down,
			hit0, hit1, hit2, hit3, hit4, hit5,
			0))
		return end;
	
	if (info) {
		/* Invalidate menu window */
		gActiveMenu_last = EMENU_NONE;
		showInfo();
	}
	else if (hit1)
	{
		mainMenu_case=MAIN_MENU_CASE_CANCEL;
		end=1;
	}
	else if (hit2)
	{
		// ???
	}
	else if (hit3)
	{
		mainMenu_case=MAIN_MENU_CASE_LOAD;
		end=1;
	}
	else if (hit4)
	{
		// reset
		back_c = c;
		hit0 = 1;
		c = 10;
	}
	else if (hit5)
	{
		// eject
		back_c = c;
		hit0 = 1;
		c = 7;
	}
	else if (up)
	{
		c--;
		if (c < 0) c = sizeof(main_menu)-2;
		#ifdef CYCLONE
		if (main_menu[c] == MAIN_SAVESTATES) c--;
		#endif
		if (main_menu[c] == MAIN_SEPARATOR) c--;
	}
	else if (down)
	{
		if(main_menu[c+1] != 0)
		{
			c++;
			#ifdef CYCLONE
			if (main_menu[c] == MAIN_SAVESTATES) c++;
			#endif
			if (main_menu[c] == MAIN_SEPARATOR) c++;
		}
		else
		{
			c = 0;
		}			
	}
	
	switch(main_menu[c])
	{
		case MAIN_LOAD:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_LOAD;
				end=1;
			}
			break;
		case MAIN_THROTTLE:
			if (left)
			{
				if (mainMenu_throttle==0)
					mainMenu_throttle=4;
				else if (mainMenu_throttle==4)
					mainMenu_throttle=2;
				else if (mainMenu_throttle==2)
					mainMenu_throttle=0;
			}
			else if (right)
			{
				if (mainMenu_throttle==0)
					mainMenu_throttle=2;
				else if (mainMenu_throttle==2)
					mainMenu_throttle=4;
				else if (mainMenu_throttle==4)
					mainMenu_throttle=0;
			}
			break;
		case MAIN_SYNC:
			if (left)
			{
				if (timeslice_mode>0)
					timeslice_mode--;
				else
					timeslice_mode=3;
			}
			else if (right)
			{
				if (timeslice_mode<3)
					timeslice_mode++;
				else
					timeslice_mode=0;
			}
			break;
		case MAIN_FRAMESKIP:
			if (left)
			{
				if (mainMenu_frameskip>-1)
					mainMenu_frameskip--;
				else
					mainMenu_frameskip=5;
			}
			else if (right)
			{
				if (mainMenu_frameskip<5)
					mainMenu_frameskip++;
				else
					mainMenu_frameskip=-1;
			}
			break;
		case MAIN_SAVESTATES:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_SAVESTATES;
				end=1;
			}
			break;
		case MAIN_MOUSESPEED:
			if (left)
			{
				if (mainMenu_mouseMultiplier > 1)
					mainMenu_mouseMultiplier--;
				else mainMenu_mouseMultiplier=5;
			}
			else if (right)
			{
				if (mainMenu_mouseMultiplier < 5)
					mainMenu_mouseMultiplier++;
				else mainMenu_mouseMultiplier=1;
			}
			break;
		case MAIN_SOUNDVOLUME: {
			if(left) {
				if (soundVolume >0)
				{
					soundVolume-= 10;
					
					gp2x_set_volume(soundVolume);
				}
			} else if (right) {
				if (soundVolume <100)
				{
					soundVolume+= 10;
					
					gp2x_set_volume(soundVolume);
				}
			}
		}break;
		case MAIN_SOUND:
			if (left)
			{
				if (mainMenu_sound > 0)
					mainMenu_sound--;
				else
					mainMenu_sound = 3;
			}
			else if (right)
			{
				if (mainMenu_sound < 3)
					mainMenu_sound++;
				else
					mainMenu_sound = 0;
			}
			break;			
		case MAIN_EJECTALL:
			// eject
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_EJECT;
				end=1;
			}
			break;
			
		case MAIN_SOUNDRATE:
			if ((left)||(right))
			{
				static int rates[] = { 8000, 11025, 22050, 32000, 44100 };
				int sel;
				for (sel = 0; sel < sizeof(rates) / sizeof(rates[0]); sel++)
					if (rates[sel] == sound_rate) break;
				sel += left ? -1 : 1;
				if (sel < 0) sel = 4;
				if (sel > 4) sel = 0;
				sound_rate = rates[sel];
			}
			break;
		case MAIN_MISC:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_MISC;
				printf("Launch main menu MISC\n");
				end=1;
			}
			break;
		case MAIN_RESET:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_RESET;
				end=1;
			}
			break;
		case MAIN_RUN:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_RUN;
				end=1;
			}
			break;
		case MAIN_SAVEGAMECONFIG:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_SAVE;
				//end=1;
				if (saveconfig())
					showWarning("Config saved for this game");
				//createScript();
			}
			break;
		/*case 13:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_SAVE;
				if (createScript(0))
					showWarning("Script created for this game");
			}
			break;*/
		case MAIN_SAVEGENERALCONFIG:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_SAVE;
				saveconfig(1);
				showWarning("General config file saved");
			}
			break;
		case MAIN_EXIT:
			if (hit0)
			{
				mainMenu_case=MAIN_MENU_CASE_REBOOT;
				end=1;
			}
			break;
	}
	
	if (back_c>=0)
	{
		c=back_c;
		back_c=-1;
	}
	
	(*cp)=c;
	return end;
}

static void raise_mainMenu()
{
#ifndef __SYMBIAN32__
	int i;

	text_draw_background();
	text_flip();
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(40,(10-i)*24,260,200,text_str_title);
		text_flip();
	}
#endif
}
/*
static void refreshDrives(int &old_drive)
{
	
	if (old_drive<mainMenu_drives) return;
	else 
	{
		int temp=mainMenu_drives;
		mainMenu_drives=old_drive;
		for(int i=temp+1;i<=old_drive;i++)
		{
			printf("Refreshing drive %d\n",i-1);
			changed_df[i-1][0]=0;
			real_changed_df[i-1]=1;
			if (i==2) uae4all_image_file1[0]=0;
			else if (i==3) uae4all_image_file2[0]=0;
			else if (i==4) uae4all_image_file3[0]=0;
			disk_eject(i-1);
		}
		mainMenu_drives=temp;
	}
	
}
*/
static void unraise_mainMenu()
{
#ifndef __SYMBIAN32__
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(40,(10-i)*24,260,200,text_str_title);
		text_flip();
	}
	text_draw_background();
	text_flip();
#endif
}

int run_mainMenu()
{
#if defined(AUTO_RUN) || defined(AUTO_FRAMERATE) || defined(AUTO_PROFILER)
	return 1;
#else
#if !defined(DEBUG_UAE4ALL) && !defined(PROFILER_UAE4ALL) 
	static int c=0;
#else
	static int c=1;
#endif
	int end;
	int old_sound_rate = sound_rate;
	mainMenu_case=-1;
#ifndef PANDORA
	setBatteryLED(0);
#endif
	
	// reinit text
	init_text(0);
	
	while(mainMenu_case<0)
	{	
		mainMenu_case=-1;
		
		raise_mainMenu();
		end=0;
		draw_mainMenu(c);
		
		while(!end) {
			draw_mainMenu(c);
			SDL_Delay(EVENT_POLLING_INTERVAL);
			end=key_mainMenu(&c);
		}
		
		unraise_mainMenu();
		
		/* Moving between the menus with numeric keys */
		while (end > 1) {
			switch(end) {
				case EMENU_MISC:
					{
						end = run_menuMisc();
					}
					break;

				case EMENU_MEMDISK:
					{
						end = run_menuMemDisk();
					}
					break;
					
				default: end = 0;
			}
		}
		
		switch(mainMenu_case)
		{
			case MAIN_MENU_CASE_LOAD:
				if(run_menuLoad(currentDir, MENU_LOAD_FLOPPY)) loadconfig();
				mainMenu_case=-1;
				break;
				
			case MAIN_MENU_CASE_SAVESTATES:
				run_menuSavestates();
				if(savestate_state == STATE_DORESTORE || savestate_state == STATE_DOSAVE)
					mainMenu_case=1;
				else
					mainMenu_case=-1;
				break;
				
			case MAIN_MENU_CASE_EJECT:
				/* Invalidate menu window */
				gActiveMenu_last = EMENU_NONE;
				
				mainMenu_case=3;
				break;
				
			case MAIN_MENU_CASE_CANCEL:
				/* Invalidate menu window */
				gActiveMenu_last = EMENU_NONE;
				
				if (emulating)
					mainMenu_case=1;
				else
					mainMenu_case=-1;
				break;
				
			case MAIN_MENU_CASE_RESET:
				/* Invalidate menu window */
				gActiveMenu_last = EMENU_NONE;
				
				gp2xMouseEmuOn=1;
				gp2xButtonRemappingOn=0;
				
				mainMenu_drives=nr_drives;
				reload_kickstart();
				reset_hdConf();
				if (emulating)
				{
					mainMenu_case=2;
					break;
				}
				
			case MAIN_MENU_CASE_RUN:
				/* Invalidate menu window */
				gActiveMenu_last = EMENU_NONE;
				reload_kickstart();
				
				mainMenu_case=1;
				break;
				
				//		case MAIN_MENU_CASE_SAVE:
				//			saveconfig();
				//			break;
				
			case MAIN_MENU_CASE_REBOOT:
				gp2x_stop_sound();	
				quit_text();

#ifndef __SYMBIAN32__
				if (gp2xClockSpeed != -1)
				{
					// try to set it back to something vaguely sane
					setGP2XClock(200);
				}
				sync();

				if (!norelaunchGP2XMenu)
				{
					chdir("/usr/gp2x");
					execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
				}			
#endif
				SDL_Quit();
				exit(0);
				break;
				
			default:
				mainMenu_case=-1;
		}
	}

	if (sound_rate != old_sound_rate)
		init_sound();

	return mainMenu_case;
#endif
}



typedef struct _cmdline_opt
{
	char *optname;
	int  len; // if 0, it means int
	void *opt;
} cmdline_opt;

static cmdline_opt cmdl_opts[] =
{
	{ "-norelaunchmenu",  0, &norelaunchGP2XMenu },
	{ "-statusln",        0, &mainMenu_showStatus },
	{ "-mousemultiplier", 0, &mainMenu_mouseMultiplier },
	{ "-sound",           0, &mainMenu_sound },
	{ "-soundrate",       0, &sound_rate },
	{ "-autosave",        0, &mainMenu_autosave },
	{ "-systemclock",     0, &mainMenu_throttle },
	{ "-syncthreshold",   0, &timeslice_mode },
	{ "-frameskip",       0, &mainMenu_frameskip },
	{ "-skipintro",       0, &skipintro },
	{ "-ntsc",            0, &mainMenu_ntsc },
	{ "-joyconf",            0, &mainMenu_joyConf },
	{ "-use1mbchip",            0, &mainMenu_chipMemory },
	{ "-autofire",            0, &mainMenu_autofire },
	{ "-drives",            0, &mainMenu_drives },
	{ "-script",            0, &mainMenu_enableScripts},
	{ "-screenshot",            0, &mainMenu_enableScreenshots},
	{ "-scaling",            0, &enableHWscaling},
	{ "-kick",            sizeof(romfile), romfile },
	{ "-df0",             sizeof(uae4all_image_file0), uae4all_image_file0 },
	{ "-df1",             sizeof(uae4all_image_file1), uae4all_image_file1 },
	{ "-df2",             sizeof(uae4all_image_file2), uae4all_image_file2 },
	{ "-df3",             sizeof(uae4all_image_file2), uae4all_image_file3 },
};
static void replace(char * str,char replace, char toreplace)
{
	while(*str)
	{	
		if (*str==toreplace) *str=replace;
		str++;
	}
}




int saveconfig(int general)
{
	
	char path[300];
	char *p; 
	int i;
	if (general) 
#ifdef __SYMBIAN32__
		sprintf(path, "%s/uaeconfig.conf", launchDir);
#else
	sprintf(path, "%s/conf/uaeconfig.conf", launchDir);
#endif
	else{
		if (!uae4all_image_file0[0]) return 0;
		p=uae4all_image_file0+strlen(uae4all_image_file0)-1;
		while (*p != '/' && *p != '\\')p--;
		p++;
		int len=strlen(p);
		char gamename[256];
		strcpy(gamename,p);
		
		char * pch;
		pch = strstr (gamename,".adf.gz");
		if (pch) strcpy(pch,"\0");
		else{
			pch = strstr (gamename,".adf");
			if (pch) strcpy(pch,"\0");
		}
		if (uae4all_image_file0[0])	
#ifdef __SYMBIAN32__
			sprintf(path, "%s/%s.conf", launchDir,gamename);
#else
		sprintf(path, "%s/conf/%s.conf", launchDir,gamename);
#endif
		else return 0;
	}
	
	FILE *f=fopen(path,"w");
	if (!f) return 0;
	char buffer[255];
	
	sprintf((char*)buffer, "kickstart=%d\n",kickstart);
	fputs(buffer,f);
	
	sprintf((char*)buffer, "scaling=%d\n",enableHWscaling);
	fputs(buffer,f);
	
	sprintf((char*)buffer, "showstatus=%d\n",mainMenu_showStatus);
	fputs(buffer,f);
	sprintf((char*)buffer, "mousemultiplier=%d\n",mainMenu_mouseMultiplier);
	fputs(buffer,f);
	sprintf((char*)buffer, "systemclock=%d\n",mainMenu_throttle);
	fputs(buffer,f);
	sprintf((char*)buffer, "syncthreshold=%d\n",timeslice_mode);
	fputs(buffer,f);
	sprintf((char*)buffer, "frameskip=%d\n",mainMenu_frameskip);
	fputs(buffer,f);
	sprintf((char*)buffer, "sound=%d\n",mainMenu_sound);
	fputs(buffer,f);
	sprintf((char*)buffer, "soundrate=%d\n",sound_rate);
	fputs(buffer,f);
	sprintf((char*)buffer, "autosave=%d\n",mainMenu_autosave);
	fputs(buffer,f);
#ifndef __SYMBIAN32__
	sprintf((char*)buffer, "gp2xclock=%d\n",gp2xClockSpeed);
	fputs(buffer,f);
#endif
	sprintf((char*)buffer, "joyconf=%d\n",mainMenu_joyConf);
	fputs(buffer,f);
	sprintf((char*)buffer, "autofire=%d\n",mainMenu_autofire);
	fputs(buffer,f);
	sprintf((char*)buffer, "drives=%d\n",nr_drives);
	fputs(buffer,f);
	sprintf((char*)buffer, "videomode=%d\n",mainMenu_ntsc);
	fputs(buffer,f);
	sprintf((char*)buffer, "movex=%d\n",mainMenu_moveX);
	fputs(buffer,f);
	sprintf((char*)buffer, "movey=%d\n",mainMenu_moveY);
	fputs(buffer,f);
   sprintf((char*)buffer, "cpu=%d\n",mainMenu_CPU_model);
   fputs(buffer,f);
	sprintf((char*)buffer, "chipset=%d\n",mainMenu_chipset);
	fputs(buffer,f);
	
	if(!general)
	{
		
		char namebuffer[128];
		strcpy(namebuffer,uae4all_image_file0);
		replace (namebuffer,'|',' ');
		sprintf((char*)buffer, "df0=%s\n",namebuffer);
		fputs(buffer,f);
		
		
		if (uae4all_image_file1[0])
		{
			strcpy(namebuffer,uae4all_image_file1);
			replace (namebuffer,'|',' ');
			sprintf((char*)buffer, "df1=%s\n",namebuffer);
			fputs(buffer,f);
		}
		else
		{
			fputs("df1=c:\\\n",f);
		}
		
		if (uae4all_image_file2[0])
		{
			strcpy(namebuffer,uae4all_image_file2);
			replace (namebuffer,'|',' ');	
			sprintf((char*)buffer, "df2=%s\n",namebuffer);
			fputs(buffer,f);
		}
		else
		{
			fputs("df2=c:\\\n",f);
		}
		
		if (uae4all_image_file3[0])
		{
			strcpy(namebuffer,uae4all_image_file3);
			replace (namebuffer,'|',' ');
			sprintf((char*)buffer, "df3=%s\n",namebuffer);
			fputs(buffer,f);
		}
		else
		{
			fputs("df3=c:\\\n",f);
		}
	}
	else {
		sprintf((char*)buffer, "script=%d\n",mainMenu_enableScripts);
		fputs(buffer,f);
		
		sprintf((char*)buffer, "screenshot=%d\n",mainMenu_enableScreenshots);
		fputs(buffer,f);
		
		sprintf((char*)buffer, "skipintro=%d\n",skipintro);
		fputs(buffer,f);
		sprintf((char*)buffer, "soundvolume=%d\n",soundVolume);	
		fputs(buffer,f);	
		sprintf((char*)buffer, "keypad_conf=%d\n",mainMenu_keypadConf);
		fputs(buffer,f);

		/* Strange bug - fscanf(..., "%s\n") will return the *next* line
		 * if scanned line is empty. Solution - space char.
		 */
		if (uae4all_hard_dir[0] == '\0')
			sprintf((char*)buffer, "current_dir=%s\n","*");
		else
			sprintf((char*)buffer, "current_dir=%s\n",currentDir);
		fputs(buffer,f);
		
		sprintf((char*)buffer, "boot_hd=%d\n",mainMenu_bootHD);
		fputs(buffer,f);
		
		if (uae4all_hard_dir[0] == '\0')
			sprintf((char*)buffer, "hard_disk_dir=%s\n","*");
		else
			sprintf((char*)buffer, "hard_disk_dir=%s\n",uae4all_hard_dir);
		fputs(buffer,f);
		
		if (uae4all_hard_file[0] == '\0')
			sprintf((char*)buffer, "hard_disk_file=%s\n","*");
		else
			sprintf((char*)buffer, "hard_disk_file=%s\n",uae4all_hard_file);
		
		fputs(buffer,f);
	}
	
   sprintf((char*)buffer, "chipmemory=%d\n",mainMenu_chipMemory);
   fputs(buffer,f);
   sprintf((char*)buffer, "slowmemory=%d\n",mainMenu_slowMemory);
   fputs(buffer,f);
   sprintf((char*)buffer, "fastmemory=%d\n",mainMenu_fastMemory);
   fputs(buffer,f);
   
	for(i = 0;i<10;i++)
		{
		sprintf(buffer,"keymapping_from%d=%d\n", i, keymappings[i][0]);
		fputs(buffer,f);
		sprintf(buffer,"keymapping_to%d=%d\n", i, keymappings[i][1]);
		fputs(buffer,f);
		sprintf(buffer,"keymapping_joy%d=%d\n", i, keymappings[i][2]);
		fputs(buffer,f);
		}

	fclose(f);
	return 1;
}

void loadconfig(int general)
{
	char path[300];
	char *p; 
	int i;
	char buffer[128];
	
	if (general)
#ifdef __SYMBIAN32__
		sprintf(path, "%s/uaeconfig.conf", launchDir);
#else
	sprintf(path, "%s/conf/uaeconfig.conf", launchDir);
#endif
	else
	{
		p=uae4all_image_file0+strlen(uae4all_image_file0)-1;
		while (*p != '/' && *p != '\\') p--;
		p++;
		int len=strlen(p);
		char gamename[256];
		strcpy(gamename,p);
		char * pch;
		pch = strstr (gamename,".adf");
		if (pch) *pch='\0';
		/*else{
				pch = strstr (gamename,".adf");
				if (pch) strcpy(pch,"\0");
	}	
		 */
#ifdef __SYMBIAN32__
		sprintf(path, "%s/%s.conf", launchDir,gamename);
#else
		sprintf(path, "%s/conf/%s.conf", launchDir,gamename);
#endif
		//	printf("read config from file %s and path %s\n",gamename,path);
		
	}
	FILE *f=fopen(path,"rt");
	if (!f){
		//printf ("No config file %s!\n",path);
		return;
	}
	char filebuffer[128];
	fscanf(f,"kickstart=%d\n",&kickstart);
	sprintf(romfile,"%s/kickstarts/%s",launchDir,kickstarts_rom_names[kickstart-1]);

	fscanf(f,"scaling=%d\n",&enableHWscaling);
	fscanf(f,"showstatus=%d\n",&mainMenu_showStatus);
	fscanf(f,"mousemultiplier=%d\n",&mainMenu_mouseMultiplier );
	fscanf(f,"systemclock=%d\n",&mainMenu_throttle);
	fscanf(f,"syncthreshold=%d\n", &timeslice_mode);
	fscanf(f,"frameskip=%d\n",&mainMenu_frameskip);
	fscanf(f,"sound=%d\n",&mainMenu_sound );
	fscanf(f,"soundrate=%d\n",&sound_rate);
	fscanf(f,"autosave=%d\n",&mainMenu_autosave);
#ifndef __SYMBIAN32__
	fscanf(f,"gp2xclock=%d\n", &gp2xClockSpeed);
#endif
	fscanf(f,"joyconf=%d\n",&mainMenu_joyConf);
	fscanf(f,"autofire=%d\n",&mainMenu_autofire);
	//int olddrives=nr_drives;
	fscanf(f,"drives=%d\n",&nr_drives);
	mainMenu_drives=nr_drives;
	fscanf(f,"videomode=%d\n",&mainMenu_ntsc);
	fscanf(f,"movex=%d\n",&mainMenu_moveX);
	moveHorizontal(mainMenu_moveX);
	fscanf(f,"movey=%d\n",&mainMenu_moveY);
	moveVertical(mainMenu_moveY);
   fscanf(f,"cpu=%d\n",&mainMenu_CPU_model);
#ifdef USE_FAME_CORE_C
   switch (mainMenu_CPU_model) {
      case 1: changed_prefs.cpu_level = M68020; break;
      default: changed_prefs.cpu_level = M68000; break;
   }
#else
   changed_prefs.cpu_level = M68000;
#endif
   fscanf(f,"chipset=%d\n",&mainMenu_chipset);
#ifdef USE_FAME_CORE_C
	switch (mainMenu_chipset) {
		case 1: changed_prefs.chipset_mask = CSMASK_ECS_AGNUS | CSMASK_ECS_DENISE; break;
		case 2: changed_prefs.chipset_mask = CSMASK_ECS_AGNUS | CSMASK_ECS_DENISE | CSMASK_AGA; break;
		default: changed_prefs.chipset_mask = CSMASK_ECS_AGNUS; break;
	}
#else
	changed_prefs.chipset_mask = CSMASK_ECS_AGNUS | CSMASK_ECS_DENISE;
#endif
//if (mainMenu_drives!=olddrives) refreshDrives(olddrives);
	if (!general) {
		fscanf(f,"df0=%s\n",&filebuffer);
		replace(filebuffer,' ','|');
		strcpy(uae4all_image_file0,filebuffer);
		
		fscanf(f,"df1=%s\n",&filebuffer);
		replace(filebuffer,' ','|');
		strcpy(uae4all_image_file1,filebuffer);
		
		fscanf(f,"df2=%s\n",&filebuffer);
		replace(filebuffer,' ','|');
		strcpy(uae4all_image_file2,filebuffer);
		
		fscanf(f,"df3=%s\n",&filebuffer);
		replace(filebuffer,' ','|');
		strcpy(uae4all_image_file3,filebuffer);
	}
	else
	{
		fscanf(f,"script=%d\n", &mainMenu_enableScripts);
		fscanf(f,"screenshot=%d\n", &mainMenu_enableScreenshots);
		fscanf(f,"skipintro=%d\n", &skipintro);
		fscanf(f,"soundvolume=%d\n", &soundVolume);
		gp2x_set_volume(soundVolume);	
		fscanf(f,"keypad_conf=%d\n", &mainMenu_keypadConf);
		
		/* Strange - fscanf(..., "%s\n") will return the *next* line
		 * if scanned line is empty. Solution - one special char.
		 */
      fscanf(f,"current_dir=",currentDir);
      currentDir[0] = '\0';
		{
		   char c[2] = {0, 0};
		   *c = fgetc(f);
	      while (*c && (*c != '\n')) {
	         strcat(currentDir, c);
	         *c = fgetc(f);
	      }
		}
		if (currentDir[0] == '*') currentDir[0] = '\0';
		
		fscanf(f,"boot_hd=%d\n",&mainMenu_bootHD);
		
		if (hd_dir_unit_nr >= 0)
			kill_filesys_unit(currprefs.mountinfo, 0);
		fscanf(f,"hard_disk_dir=",uae4all_hard_dir);
		uae4all_hard_dir[0] = '\0';
      {
         char c[2] = {0, 0};
         *c = fgetc(f);
         while (*c && (*c != '\n')) {
            strcat(uae4all_hard_dir, c);
            *c = fgetc(f);
         }
      }
		if (uae4all_hard_dir[0] == '*') uae4all_hard_dir[0] = '\0';
		
		if (hd_file_unit_nr >= 0)
			kill_filesys_unit(currprefs.mountinfo, 0);
		fscanf(f,"hard_disk_file=",uae4all_hard_file);
		uae4all_hard_file[0] = '\0';
      {
         char c[2] = {0, 0};
         *c = fgetc(f);
         while (*c && (*c != '\n')) {
            strcat(uae4all_hard_file, c);
            *c = fgetc(f);
         }
      }
		if (uae4all_hard_file[0] == '*') uae4all_hard_file[0] = '\0';
	}

   fscanf(f,"chipmemory=%d\n",&mainMenu_chipMemory);
   prefs_chipmem_size = 0x000080000 << mainMenu_chipMemory;
   
   fscanf(f,"slowmemory=%d\n",&mainMenu_slowMemory);
   switch (mainMenu_slowMemory) {
      case 1: case 2:
         prefs_bogomem_size = 0x00080000 << (mainMenu_slowMemory - 1);
         break;
      case 3:
         prefs_bogomem_size = 0x00180000; /* 1.5M */
         break;
      default:
         prefs_bogomem_size = 0;
   }
   
   fscanf(f,"fastmemory=%d\n",&mainMenu_fastMemory);
   switch (mainMenu_fastMemory) {
      case 0:
         changed_prefs.fastmem_size = 0;
         break;
      default:
         changed_prefs.fastmem_size = 0x00080000 << mainMenu_fastMemory;
   }
   
	for(i = 0;i<10;i++) {
      sprintf(buffer,"keymapping_from%d=", i);
      strcat(buffer,"%d\n");
      fscanf(f, buffer, &keymappings[i][0]);
      
      sprintf(buffer,"keymapping_to%d=", i);
      strcat(buffer,"%d\n");
      fscanf(f, buffer, &keymappings[i][1]);
      
      sprintf(buffer,"keymapping_joy%d=", i);
      strcat(buffer,"%d\n");
      fscanf(f, buffer, &keymappings[i][2]);
   }
	
	fclose(f);
	set_joyConf();
	reset_hdConf();
}

void parse_cmdline(int argc, char **argv)
{
	int arg, i, found;

	for (arg = 1; arg < argc-1; arg++)
	{
		for (i = found = 0; i < sizeof(cmdl_opts) / sizeof(cmdl_opts[0]); i++)
		{
			if (strcmp(argv[arg], cmdl_opts[i].optname) == 0)
			{
				arg++;
				if (cmdl_opts[i].len == 0)
					*(int *)(cmdl_opts[i].opt) = atoi(argv[arg]);
				else
				{
					strncpy((char *)cmdl_opts[i].opt, argv[arg], cmdl_opts[i].len);
					((char *)cmdl_opts[i].opt)[cmdl_opts[i].len-1] = 0;
				}
				found = 1;
				break;
			}
		}
		if (!found) printf("skipping unknown option: \"%s\"\n", argv[arg]);
	}
}
