#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include "menu.h"

#include <sys/stat.h>
#include <unistd.h>
#include<dirent.h>

#include "sysconfig.h"
#include "sysdeps.h"
#include "autoconf.h"
#include "uae.h"
#include "options.h"
#include "sound.h"
#include <SDL.h>
#include "gp2x.h"
#include <SDL_ttf.h>
static char *text_str_status_line="Status ln";

/* PocketUAE config file. Used for parsing PocketUAE-like options. */
#include "cfgfile.h" 

char *text_str_memdisk_separator="---------------------------------*----";
char *text_str_memdisk_title=    "     Memory and Disk Options     -";
char *text_str_off="off";
char *text_str_on="on";
char *text_str_512K="512K";
char *text_str_1M="1M";
char *text_str_1_5M="1.5M";
char *text_str_2M="2M";
char *text_str_4M="4M";
char *text_str_8M="8M";

int menuMemDisk = 0;
int memDiskMenu_case = -1;

extern int mainMenu_ntsc;
extern int mainMenu_useExternalDrive;
extern int mainMenu_chipMemory;
extern int mainMenu_slowMemory;
extern int mainMenu_fastMemory;
extern int mainMenu_bootHD;
extern int mainMenu_joyConf;
extern int mainMenu_autosave;
extern int mainMenu_autofire;
extern int mainMenu_showStatus;
extern int skipintro;
extern int enableHWscaling;

extern int mainMenu_filesysUnits;
extern int hd_dir_unit_nr;
extern int hd_file_unit_nr;

extern char uae4all_hard_dir[];
extern char uae4all_hard_file[];

extern int mainMenu_enableScreenshots;
extern int mainMenu_enableScripts;
extern int nr_drives;
extern int kickstart;
extern SDL_Joystick *uae4all_joy0;

extern char currentDir[];

static void draw_memDiskMenu(int c)
{
	static bool bb = false;		/* Inverted/normal selection drawing */
	static int c_last;			/* Last selection */
	static bool bInitialized;	/* Window is drawn only once, except when menu changes */

	int leftMargin=3;
	int tabstop1 = 17;
	int tabstop2 = 19;
	int tabstop3 = 21;
	int tabstop4 = 23;
	int tabstop5 = 25;
	int tabstop6 = 27;
	int tabstop7 = 29;
	int tabstop8 = 31;
	int tabstop9 = 33;
	
	int menuLine = 3;
	SDL_Rect r;
	extern SDL_Surface *text_screen;
	
	/* Should menu window be refreshed ? */  
	if (!CheckMenuRefresh(EMENU_MEMDISK, c, c_last, &bb, &bInitialized))
		return;
	
	r.x=80-64; r.y=0; r.w=110+64+64; r.h=240;

	if (!bInitialized) {
		text_draw_background();
		text_draw_window(2,2,40,30,text_str_memdisk_title);
	}
	
	if ((0 == c)||(0 == c_last) || !bInitialized )
		if ((menuMemDisk == 0)&&(c==0)&&(bb))
			write_text_inv(3, menuLine, "Misc Menu",0);
		else
			write_text_norm(3, menuLine, "Misc Menu",0);

	menuLine++;
	if (!bInitialized) write_text(3, menuLine, text_str_memdisk_separator,0);
	menuLine++;
	
	if (!bInitialized) write_text(leftMargin,menuLine,"Chip Memory",0);
	if ((1 == c)||(1 == c_last) || !bInitialized ) {
		if ((mainMenu_chipMemory==0)&&((c!=1)||(!bb)))
			write_text_inv(tabstop3 + 4,menuLine,text_str_512K,0);
		else
			write_text_norm(tabstop3 + 4,menuLine,text_str_512K,0);
		
		if ((mainMenu_chipMemory==1)&&((c!=1)||(!bb)))
			write_text_inv(tabstop3 + 9,menuLine,text_str_1M,0);
		else
			write_text_norm(tabstop3 + 9,menuLine,text_str_1M,0);

		if ((mainMenu_chipMemory==2)&&((c!=1)||(!bb)))
			write_text_inv(tabstop3 + 12,menuLine,text_str_2M,0);
		else
			write_text_norm(tabstop3 + 12,menuLine,text_str_2M,0);

		if ((mainMenu_chipMemory==3)&&((c!=1)||(!bb)))
			write_text_inv(tabstop3 + 15,menuLine,text_str_4M,0);
		else
			write_text_norm(tabstop3 + 15,menuLine,text_str_4M,0);
		
		if ((mainMenu_chipMemory==4)&&((c!=1)||(!bb)))
			write_text_inv(tabstop3 + 18,menuLine,text_str_8M,0);
		else
			write_text_norm(tabstop3 + 18,menuLine,text_str_8M,0);
	}
	
	menuLine+=2;
	if (!bInitialized) write_text(leftMargin,menuLine,"Slow Memory",0);
	if ((2 == c)||(2 == c_last) || !bInitialized ) {
		if ((mainMenu_slowMemory==0)&&((c!=2)||(!bb)))
			write_text_inv(tabstop3,menuLine,text_str_off,0);
		else
			write_text_norm(tabstop3,menuLine,text_str_off,0);
		
		if ((mainMenu_slowMemory==1)&&((c!=2)||(!bb)))
			write_text_inv(tabstop3 + 4,menuLine,text_str_512K,0);
		else
			write_text_norm(tabstop3 + 4,menuLine,text_str_512K,0);
		
		if ((mainMenu_slowMemory==2)&&((c!=2)||(!bb)))
			write_text_inv(tabstop3 + 9,menuLine,text_str_1M,0);
		else
			write_text_norm(tabstop3 + 9,menuLine,text_str_1M,0);

		if ((mainMenu_slowMemory==3)&&((c!=2)||(!bb)))
			write_text_inv(tabstop3 + 12,menuLine,text_str_1_5M,0);
		else
			write_text_norm(tabstop3 + 12,menuLine,text_str_1_5M,0);
	}
	
	menuLine+=2;
	if (!bInitialized) write_text(leftMargin,menuLine,"Fast Memory",0);
	if ((3 == c)||(3 == c_last) || !bInitialized ) {
		if ((mainMenu_fastMemory==0)&&((c!=3)||(!bb)))
			write_text_inv(tabstop3,menuLine,text_str_off,0);
		else
			write_text_norm(tabstop3,menuLine,text_str_off,0);

		if ((mainMenu_fastMemory==1)&&((c!=3)||(!bb)))
			write_text_inv(tabstop3 + 9,menuLine,text_str_1M,0);
		else
			write_text_norm(tabstop3 + 9,menuLine,text_str_1M,0);
		
		if ((mainMenu_fastMemory==2)&&((c!=3)||(!bb)))
			write_text_inv(tabstop3 + 12,menuLine,text_str_2M,0);
		else
			write_text_norm(tabstop3 + 12,menuLine,text_str_2M,0);

		if ((mainMenu_fastMemory==3)&&((c!=3)||(!bb)))
			write_text_inv(tabstop3 + 15,menuLine,text_str_4M,0);
		else
			write_text_norm(tabstop3 + 15,menuLine,text_str_4M,0);

		if ((mainMenu_fastMemory==4)&&((c!=3)||(!bb)))
			write_text_inv(tabstop3 + 18,menuLine,text_str_8M,0);
		else
			write_text_norm(tabstop3 + 18,menuLine,text_str_8M,0);
	}
	
	menuLine++;
	if (!bInitialized) write_text(3, menuLine, text_str_memdisk_separator,0);
	menuLine++;
	
	if (!bInitialized) write_text(leftMargin,menuLine,"Number of drives:",0);
	if ((4 == c)||(4 == c_last) || !bInitialized ) {
		if ((nr_drives==1)&&((c!=4)||(!bb)))
			write_text_inv(tabstop3,menuLine,"1",0);
		else
			write_text_norm(tabstop3,menuLine,"1",0);
		if ((nr_drives==2)&&((c!=4)||(!bb)))
			write_text_inv(tabstop4,menuLine,"2",0);
		else
			write_text_norm(tabstop4,menuLine,"2",0);
		if ((nr_drives==3)&&((c!=4)||(!bb)))
			write_text_inv(tabstop5,menuLine,"3",0);
		else
			write_text_norm(tabstop5,menuLine,"3",0);
		if ((nr_drives==4)&&((c!=4)||(!bb)))
			write_text_inv(tabstop6,menuLine,"4",0);
		else
			write_text_norm(tabstop6,menuLine,"4",0);
	}
	
	menuLine++;
	if (!bInitialized) write_text(3, menuLine, text_str_memdisk_separator,0);
	menuLine++;
	
	if (!bInitialized) write_text(leftMargin,menuLine,"Boot HD",0);
	if ((5 == c)||(5 == c_last) || !bInitialized ) {
		if ((mainMenu_bootHD==0)&&((c!=5)||(!bb)))
			write_text_inv(tabstop3,menuLine,text_str_off,0);
		else
			write_text_norm(tabstop3,menuLine,text_str_off,0);

		if ((mainMenu_bootHD==1)&&((c!=5)||(!bb)))
			write_text_inv(tabstop3 + 7,menuLine,"Dir",0);
		else
			write_text_norm(tabstop3 + 7,menuLine,"Dir",0);
		
		if ((mainMenu_bootHD==2)&&((c!=5)||(!bb)))
			write_text_inv(tabstop3 + 12,menuLine,"File",0);
		else
			write_text_norm(tabstop3 + 12,menuLine,"File",0);
	}
	
	menuLine+=2;

	{
		char str[128];
		int i;
		
		strcpy(str, "HD Dir");
		if ((c==6)&&(bb))
			write_text_inv(leftMargin + 2,menuLine,str,0);
		else
			write_text_norm(leftMargin + 2,menuLine,str,0);
		for (i = strlen(uae4all_hard_dir); i > 0; i--)
			if ((uae4all_hard_dir[i] == '/')||(uae4all_hard_dir[i] == '\\'))
				break;
		if (i > 0) {
			strcpy(str, &uae4all_hard_dir[i+1]);
			if (strlen(str) > (MENU_MEMDISK_WINDOW_WIDTH - tabstop1))
				str[MENU_MEMDISK_WINDOW_WIDTH - tabstop1] = '\0';
			write_text_norm(tabstop1,menuLine,str,0);
		} else
			write_text_norm(tabstop1,menuLine,"",MENU_MEMDISK_WINDOW_WIDTH - tabstop1);
		
		menuLine += 2;
		
		strcpy(str, "HD File");
		if ((c==7)&&(bb))
			write_text_inv(leftMargin + 2,menuLine,str,0);
		else
			write_text_norm(leftMargin + 2,menuLine,str,0);
		for (i = strlen(uae4all_hard_file); i > 0; i--)
			if ((uae4all_hard_file[i] == '/') || (uae4all_hard_file[i] == '\\'))
				break;
		if (i > 0) {
			strcpy(str, &uae4all_hard_file[i+1]);
			if (strlen(str) > MENU_MEMDISK_WINDOW_WIDTH - tabstop1)
				str[MENU_MEMDISK_WINDOW_WIDTH - tabstop1] = '\0';
			write_text_norm(tabstop1,menuLine,str,0);
		} else
			write_text_norm(tabstop1,menuLine,"",MENU_MEMDISK_WINDOW_WIDTH - tabstop1);
	}
	
	menuLine++;
	if (!bInitialized) write_text(3, menuLine, text_str_memdisk_separator,0);
	menuLine++;
	
	text_flip();
	
	/* Last active option */
	c_last = c;
	
	/* Window has been completely drawn */
	bInitialized = true;
}

void update_joystick(int& left, int& right, int& up, int& down);

static int key_memDiskMenu(int *c)
{
	int end=0;
	int left=0, right=0, up=0, down=0;
	int hit0=0, hit1=0, hit2=0, hit3=0, hit4=0, hit5=0;
	int del=0;
	SDL_Joystick *joy = uae4all_joy0 ;
	
#ifndef __SYMBIAN32__
	SDL_JoystickUpdate ();
#endif
	
#ifndef __SYMBIAN32__
	if (SDL_JoystickGetButton(joy, GP2X_BUTTON_RIGHT)) right=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_LEFT)) left=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_UP)) up=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_DOWN)) down=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_B)) hit0=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_START)) {printf("Pressed Start\n");hit1=1;}
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_X)) hit0=1;
#endif
	
	SDL_Event event;
	
	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
			end=-1;
		else if (event.type == SDL_JOYBUTTONDOWN)
		{
			switch (event.jbutton.button)
			{
#ifdef __SYMBIAN32__
				case 0:hit0=1; break;
				case 1:
				case 2:hit1=1;break;
#else
				case GP2X_BUTTON_UP: up=1; break;
				case GP2X_BUTTON_LEFT: left=1; break;
				case GP2X_BUTTON_RIGHT: right=1; break;
				case GP2X_BUTTON_DOWN: down=1; break;
				case GP2X_BUTTON_X: hit0=1; break;
				case GP2X_BUTTON_B: hit0=1; break;
				case GP2X_BUTTON_START: hit1=1; break;
#endif
			}
		}	
		else
			if (event.type == SDL_KEYDOWN)
			{
				uae4all_play_click();
				switch(event.key.keysym.sym)
				{
					case SDLK_RIGHT: right=1; break;
					case SDLK_LEFT: left=1; break;
					case SDLK_UP: up=1; break;
					case SDLK_DOWN: down=1; break;
					case SDLK_RETURN:
					case SDLK_LCTRL: hit0=1; break;
					case SDLK_LALT: hit1=1; break;
					case SDLK_1: memDiskMenu_case = MEMDISK_MENU_CASE_MAIN; end = EMENU_MAIN; break;
					case SDLK_2: memDiskMenu_case = MEMDISK_MENU_CASE_MISC; end = EMENU_MISC; break;
					case SDLK_3: break;
					case SDLK_DELETE: case SDLK_BACKSPACE: case SDLK_ESCAPE: del=1; break;
					default:
						break;
				}
			}
	}
	
#ifdef __SYMBIAN32__
	update_joystick(left, right, up, down);
#endif		
	
	/* Interval for checking key/joy events */
	if (!CheckKeyJoyRefresh(
			left, right, up, down,
			hit0, hit1, hit2, hit3, hit4, hit5,
			0))
		return 0;
	
	if (hit1)
	{
		end=-1;
	}
	else if (up)
	{
		if (menuMemDisk==0) menuMemDisk=7;
		else menuMemDisk--;
	}
	else if (down)
	{
		if (menuMemDisk==7) menuMemDisk=0;
		else menuMemDisk++;	
	}
	
	switch (menuMemDisk)
	{
		case 0:
			if (hit0)
				end = 1;
			break;
		case 1:
			if ((left)||(right)) {
				if (right) {
					if (mainMenu_chipMemory < 4)
						mainMenu_chipMemory++;
					else
						mainMenu_chipMemory = 0;
				} else if (left) {
					if (mainMenu_chipMemory > 0)
						mainMenu_chipMemory--;
					else
						mainMenu_chipMemory = 4;
				}
				
				prefs_chipmem_size = 0x000080000 << mainMenu_chipMemory;

				/* >2MB chip memory => 0 fast memory */
				if ((mainMenu_chipMemory > 2) && (mainMenu_fastMemory > 0)){
					mainMenu_fastMemory = 0;
					changed_prefs.fastmem_size = 0;
					/* Invalidate window */
					gActiveMenu_last = EMENU_NONE;
				}
			}
			break;
		case 2:
			if ((left)||(right)) {
				if (right) {
					if (mainMenu_slowMemory < 3)
						mainMenu_slowMemory++;
					else
						mainMenu_slowMemory = 0;
				} else if (left) {
					if (mainMenu_slowMemory > 0)
						mainMenu_slowMemory--;
					else
						mainMenu_slowMemory = 3;
				}
				
				switch (mainMenu_slowMemory) {
					case 1: case 2:
						prefs_bogomem_size = 0x00080000 << (mainMenu_slowMemory - 1);
						break;
					case 3:
						prefs_bogomem_size = 0x00180000;	/* 1.5M */
						break;
					default:
						prefs_bogomem_size = 0;
				}
			}
			break;
		case 3:
			if ((left) || (right)) {
				if (right) {
					if (mainMenu_fastMemory < 4)
						mainMenu_fastMemory++;
					else
						mainMenu_fastMemory = 0;
				} else if (left) {
					if (mainMenu_fastMemory > 0)
						mainMenu_fastMemory--;
					else
						mainMenu_fastMemory = 4;
				}
				
				switch (mainMenu_fastMemory) {
					case 0:
						changed_prefs.fastmem_size = 0;
						break;
					default:
						changed_prefs.fastmem_size = 0x00080000 << mainMenu_fastMemory;
				}
				
				/* Fast memory > 0 => max 2MB chip memory */
				if ((mainMenu_fastMemory > 0) && (mainMenu_chipMemory > 2)) {
					mainMenu_chipMemory = 2;
					prefs_chipmem_size = 0x00200000;
					/* Invalidate window */
					gActiveMenu_last = EMENU_NONE;
				}
			}
			break;
		case 4:
			if (left)
			{
				if (nr_drives>1)
					nr_drives--;
				else
					nr_drives=4;
			}
			else if (right)
			{
				if (nr_drives<4)
					nr_drives++;
				else
					nr_drives=1;
			}	
			break;
		case 5:
			if (left) {
				if (mainMenu_bootHD > 0)
					mainMenu_bootHD--;
				else
					mainMenu_bootHD = 2;
			} else if (right) {
				if (mainMenu_bootHD < 2)
					mainMenu_bootHD++;
				else
					mainMenu_bootHD = 0;
			}
			break;
		case 6:
			if (hit0) {
				if (run_menuLoad(currentDir, MENU_LOAD_HD_DIR)) {
					if (hd_dir_unit_nr >= 0) {
						kill_filesys_unit(currprefs.mountinfo, 0);
						mainMenu_filesysUnits--;
						hd_dir_unit_nr = -1;
					}
					make_hard_dir_cfg_line(uae4all_hard_dir);
					if ((uae4all_hard_dir[0] != '\0') && (mainMenu_bootHD > 0)) {
						parse_filesys_spec(0, uae4all_hard_dir);
						hd_dir_unit_nr = mainMenu_filesysUnits++;
					}
				}
			} else if (del) {
				uae4all_hard_dir[0] = '\0';
				/* Invalidate window */
				gActiveMenu_last = EMENU_NONE;
			}
			break;
		case 7:
			if (hit0) {
				if (run_menuLoad(currentDir, MENU_LOAD_HDF)) {
					if (hd_file_unit_nr >= 0) {
						kill_filesys_unit(currprefs.mountinfo, 0);
						mainMenu_filesysUnits--;
						hd_file_unit_nr = -1;
					}
					make_hard_file_cfg_line(uae4all_hard_file);
					if ((uae4all_hard_file[0] != '\0') && (mainMenu_bootHD > 0)) {
						parse_hardfile_spec(uae4all_hard_file);
						hd_file_unit_nr = mainMenu_filesysUnits++;
					}
				}
			} else if (del) {
				uae4all_hard_file[0] = '\0';
				/* Invalidate window */
				gActiveMenu_last = EMENU_NONE;
			}
	}
	
	*c = menuMemDisk;
	
	return end;
}

static void raise_memDiskMenu()
{
#ifndef __SYMBIAN32__
	int i;

	text_draw_background();
	text_flip();
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(80-64,(10-i)*24,160+64+64,220,text_str_memdisk_title);
		text_flip();
	}
#endif
}

static void unraise_memDiskMenu()
{
#ifndef __SYMBIAN32__
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(80-64,(10-i)*24,160+64+64,220,text_str_memdisk_title);
		text_flip();
	}
	text_draw_background();
	text_flip();
#endif
}
int run_menuMemDisk()
{
	SDL_Event event;
	
	SDL_Delay(150);
	while(SDL_PollEvent(&event))
		SDL_Delay(10);
	int end=0,c=0;
	raise_memDiskMenu();
	
	while(!end)
	{
		memDiskMenu_case = -1;
		
		draw_memDiskMenu(c);
		SDL_Delay(EVENT_POLLING_INTERVAL);
		end = key_memDiskMenu(&c);
	}
	
	unraise_memDiskMenu();
	return end;
}
