#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include "menu.h"

#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>

#include "sysconfig.h"
#include "sysdeps.h"
#include "uae.h"
#include "options.h"
#include "sound.h"
#include <SDL.h>
#include "gp2x.h"
#include <SDL_ttf.h>
#include "custom.h"

extern void moveHorizontal(int value);
extern void moveVertical(int value);

static char *text_str_status_line="On-screen LEDs";
enum Menu_Misc
	{
		MISC_RETURNTOMAIN = 1,
		MISC_VIDEOMODE,			
		MISC_NODRIVES,
		MISC_KICKSTART,
		MISC_AUTOSAVE,
		MISC_AUTOFIRE,
		MISC_ONSCREENLED,
		MISC_SPLASHSCREEN,
		MISC_SNAPSHOT,
		MISC_CONTROLCONFIG,
		MISC_SEPARATOR,
		MISC_HWSCALING,
		MISC_ENABLESCRIPTS,
		MISC_REMAPPINGMENU,
		MISC_DISKMENU,
		MISC_PADCONFIG,
		MISC_SCROFFSETX,
		MISC_SCROFFSETY,
		MISC_CHIPSET,
		MISC_CPU
	};

const char misc_menu[] = 
	{
		MISC_DISKMENU,
#ifdef USE_FAME_CORE_C
		MISC_CPU,
		MISC_CHIPSET,
#endif
		MISC_VIDEOMODE,				
		MISC_KICKSTART,
		MISC_SEPARATOR,
		MISC_AUTOSAVE,
		MISC_AUTOFIRE,
		MISC_ONSCREENLED,
		MISC_SPLASHSCREEN,
		MISC_SEPARATOR,
		MISC_SCROFFSETX,
		MISC_SCROFFSETY,
		MISC_SEPARATOR,
		MISC_REMAPPINGMENU,
		MISC_PADCONFIG,
		MISC_SEPARATOR,
		MISC_RETURNTOMAIN,
		0
	};

char *text_str_misc_separator="----------------------------------";
char *text_str_misc_title=    "      Miscellanous Options       -";
int miscMenu_menuSelect = 0;
int miscMenu_case=-1;

extern int mainMenu_CPU_model;
extern int mainMenu_chipset;
extern int mainMenu_ntsc;
extern int mainMenu_useExternalDrive;
extern int mainMenu_chipMemory;
extern int mainMenu_joyConf;
extern int mainMenu_autosave;
extern int mainMenu_autofire;
extern int mainMenu_showStatus;
extern int skipintro;
extern int enableHWscaling;
extern int mainMenu_keypadConf;
extern int mainMenu_moveX;
extern int mainMenu_moveY;

extern int mainMenu_enableScreenshots;
extern int mainMenu_enableScripts;
extern int nr_drives;
extern int kickstart;
extern SDL_Joystick *uae4all_joy0;

static void draw_miscMenu(int c)
{
	static bool bb = false;		/* Inverted/normal selection drawing */
	static int c_last;			/* Last selection */
	static bool bInitialized;	/* Window is drawn only once, except when menu changes */

	int leftMargin=3;
	int tabstop1 = 17;
	int tabstop2 = 19;
	int tabstop3 = 21;
	int tabstop4 = 23;
	int tabstop5 = 25;
	int tabstop6 = 27;
	int tabstop7 = 29;
	int tabstop8 = 31;
	int tabstop9 = 33;
   int tabstop10 = 35;
	
	int menuLine = 3;
	int menuItem = 0;
	extern SDL_Surface *text_screen;
	
	/* Should menu window be refreshed ? */  
	if (!CheckMenuRefresh(EMENU_MISC, c, c_last, &bb, &bInitialized))
		return;
	
	if (!bInitialized) {
		text_draw_background();
		text_draw_window(2,2,MENU_MISC_WINDOW_WIDTH,30,text_str_misc_title);
	}
	
	while(misc_menu[menuItem] != 0)
	{
		if (misc_menu[menuItem]==MISC_SEPARATOR) {
			menuLine--;
			write_text(leftMargin,menuLine,text_str_misc_separator);
		} else if (menuItem > 0) {
			if (misc_menu[menuItem-1]==MISC_SEPARATOR)
				menuLine--;
		}
		
		if ((c==menuItem)||(c_last==menuItem)||!bInitialized )
		{
			char strbuff[32] = { '\0', };

			switch(misc_menu[menuItem])
			{
				case MISC_DISKMENU:
					if (misc_menu[c] == MISC_DISKMENU && bb)
						write_text_inv(leftMargin, menuLine, "Memory and Disk Menu");
					else
						write_text_norm(leftMargin, menuLine, "Memory and Disk Menu");
					break;
					
				case MISC_SCROFFSETX:
					if (!bInitialized) write_text(leftMargin,menuLine,"Move X");
					
					sprintf(strbuff, "%d", mainMenu_moveX);
					
					if (misc_menu[c] == MISC_SCROFFSETX && bb)
						write_text_inv(tabstop3, menuLine, strbuff, 5);
					else
						write_text_norm(tabstop3, menuLine, strbuff, 5);
					break;
					
				case MISC_SCROFFSETY:
					if (!bInitialized) write_text(leftMargin,menuLine,"Move Y");
					
					sprintf(strbuff, "%d", mainMenu_moveY);
					
					if (misc_menu[c] == MISC_SCROFFSETY && bb)
						write_text_inv(tabstop3, menuLine, strbuff, 5);
					else
						write_text_norm(tabstop3, menuLine, strbuff, 5);
					break;
					
				case MISC_REMAPPINGMENU:
					if (misc_menu[c] == MISC_REMAPPINGMENU && bb)
						write_text_inv(leftMargin, menuLine, "Remap keys");
					else
						write_text_norm(leftMargin, menuLine, "Remap keys");
					break;
					
				case MISC_RETURNTOMAIN: {
					if (misc_menu[c] == MISC_RETURNTOMAIN && bb)
						write_text_inv(leftMargin, menuLine, "Return to main menu");
					else
						write_text_norm(leftMargin, menuLine, "Return to main menu");
				}break;
				
            case MISC_CPU: {
               if (!bInitialized) write_text(leftMargin,menuLine,"CPU");
               
               if ((mainMenu_CPU_model==0)&&((misc_menu[c]!=MISC_CPU)||(!bb)))
                  write_text_inv(tabstop3,menuLine,"68000");
               else
                  write_text_norm(tabstop3,menuLine,"68000");
               
               if ((mainMenu_CPU_model==1)&&((misc_menu[c]!=MISC_CPU)||(!bb)))
                  write_text_inv(tabstop6,menuLine,"68020");
               else
                  write_text_norm(tabstop6,menuLine,"68020");
            }break;

            case MISC_CHIPSET: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Custom Chipset");
					
					if ((mainMenu_chipset==0)&&((misc_menu[c]!=MISC_CHIPSET)||(!bb)))
						write_text_inv(tabstop3,menuLine,"OCS");
					else
						write_text_norm(tabstop3,menuLine,"OCS");
					
					if ((mainMenu_chipset==1)&&((misc_menu[c]!=MISC_CHIPSET)||(!bb)))
						write_text_inv(tabstop5,menuLine,"ECS");
					else
						write_text_norm(tabstop5,menuLine,"ECS");
					
					if ((mainMenu_chipset==2)&&((misc_menu[c]!=MISC_CHIPSET)||(!bb)))
						write_text_inv(tabstop7,menuLine,"AGA");
					else
						write_text_norm(tabstop7,menuLine,"AGA");
				}break;
				
				case MISC_VIDEOMODE: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Video Mode");
					
					if ((!mainMenu_ntsc)&&((misc_menu[c]!=MISC_VIDEOMODE)||(!bb)))
						write_text_inv(tabstop3,menuLine,"PAL");
					else
						write_text_norm(tabstop3,menuLine,"PAL");
					
					if ((mainMenu_ntsc)&&((misc_menu[c]!=MISC_VIDEOMODE)||(!bb)))
						write_text_inv(tabstop5,menuLine,"NTSC");
					else
						write_text_norm(tabstop5,menuLine,"NTSC");
					
				}break;
				
				case MISC_AUTOSAVE: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Auto Save");
					
					if ((!mainMenu_autosave)&&((misc_menu[c]!=MISC_AUTOSAVE)||(!bb)))
						write_text_inv(tabstop3,menuLine,"On");
					else
						write_text_norm(tabstop3,menuLine,"On");
					
					if ((mainMenu_autosave)&&((misc_menu[c]!=MISC_AUTOSAVE)||(!bb)))
						write_text_inv(tabstop5,menuLine,"Off");
					else
						write_text_norm(tabstop5,menuLine,"Off");
					
				}break;
				
				case MISC_PADCONFIG: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Keypad config",0);
					
               if ((mainMenu_keypadConf==0)&&((MISC_PADCONFIG != misc_menu[c])||(!bb)))
                  write_text_inv(tabstop3,menuLine,"0");
               else
                  write_text_norm(tabstop3,menuLine,"0");
               if ((mainMenu_keypadConf==1)&&((MISC_PADCONFIG != misc_menu[c])||(!bb)))
                  write_text_inv(tabstop4,menuLine,"1");
               else
                  write_text_norm(tabstop4,menuLine,"1");
               if ((mainMenu_keypadConf==2)&&((MISC_PADCONFIG != misc_menu[c])||(!bb)))
                  write_text_inv(tabstop5,menuLine,"2");
               else
                  write_text_norm(tabstop5,menuLine,"2");
               if ((mainMenu_keypadConf==3)&&((MISC_PADCONFIG != misc_menu[c])||(!bb)))
                  write_text_inv(tabstop6,menuLine,"3");
               else
                  write_text_norm(tabstop6,menuLine,"3");
               if ((mainMenu_keypadConf==4)&&((MISC_PADCONFIG != misc_menu[c])||(!bb)))
                  write_text_inv(tabstop7,menuLine,"4");
               else
                  write_text_norm(tabstop7,menuLine,"4");
               if ((mainMenu_keypadConf==5)&&((MISC_PADCONFIG != misc_menu[c])||(!bb)))
                  write_text_inv(tabstop8,menuLine,"5");
               else
                  write_text_norm(tabstop8,menuLine,"5");
               if ((mainMenu_keypadConf==6)&&((MISC_PADCONFIG != misc_menu[c])||(!bb)))
                  write_text_inv(tabstop9,menuLine,"6");
               else
                  write_text_norm(tabstop9,menuLine,"6");
               if ((mainMenu_keypadConf==7)&&((MISC_PADCONFIG != misc_menu[c])||(!bb)))
                  write_text_inv(tabstop10,menuLine,"7");
               else
                  write_text_norm(tabstop10,menuLine,"7");

               if ((MISC_PADCONFIG == misc_menu[c])||(!bInitialized)) {
						if (mainMenu_keypadConf==0)
							write_text_norm(leftMargin+3,menuLine+2,"Off",30);
						else if (mainMenu_keypadConf==1)
							write_text_norm(leftMargin+3,menuLine+2,"Joystick/mouse - normal",30);
						else if (mainMenu_keypadConf==2)
							write_text_norm(leftMargin+3,menuLine+2,"Joystick/mouse - inverted",30);
						else if (mainMenu_keypadConf==3)
							write_text_norm(leftMargin+3,menuLine+2,"Joystick/mouse - rotated right",30);
						else if (mainMenu_keypadConf==4)
							write_text_norm(leftMargin+3,menuLine+2,"Joystick/mouse - rotated left",30);
                  else if (mainMenu_keypadConf==5)
                     write_text_norm(leftMargin+3,menuLine+2,"Joystick/mouse - Q-W-E...",30);
                  else if (mainMenu_keypadConf==6)
                     write_text_norm(leftMargin+3,menuLine+2,"Joystick/mouse - I-O-P...",30);
                  else if (mainMenu_keypadConf==7)
                     write_text_norm(leftMargin+3,menuLine+2,"Joystick/mouse - Q-A-O-P",30);
					}
				}break;
				
//				case MISC_NODRIVES: {
//					if (!bInitialized) write_text(leftMargin,menuLine,"Number of drives:");
//					
//					if ((nr_drives==1)&&((misc_menu[c]!=MISC_NODRIVES)||(!bb)))
//						write_text_inv(tabstop3,menuLine,"1");
//					else
//						write_text_norm(tabstop3,menuLine,"1");
//					
//					if ((nr_drives==2)&&((misc_menu[c]!=MISC_NODRIVES)||(!bb)))
//						write_text_inv(tabstop4,menuLine,"2");
//					else
//						write_text_norm(tabstop4,menuLine,"2");
//					
//					if ((nr_drives==3)&&((misc_menu[c]!=MISC_NODRIVES)||(!bb)))
//						write_text_inv(tabstop5,menuLine,"3");
//					else
//						write_text_norm(tabstop5,menuLine,"3");
//					
//					if ((nr_drives==4)&&((misc_menu[c]!=MISC_NODRIVES)||(!bb)))
//						write_text_inv(tabstop6,menuLine,"4");
//					else
//						write_text_norm(tabstop6,menuLine,"4");
//				}break;
				
				case MISC_AUTOFIRE: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Use Autofire");
					
					if ((mainMenu_autofire)&&((misc_menu[c]!=MISC_AUTOFIRE)||(!bb)))
						write_text_inv(tabstop3,menuLine,"Yes");
					else
						write_text_norm(tabstop3,menuLine,"Yes");
					
					if ((!mainMenu_autofire)&&((misc_menu[c]!=MISC_AUTOFIRE)||(!bb)))
						write_text_inv(tabstop5,menuLine,"No");
					else
						write_text_norm(tabstop5,menuLine,"No");
					
				}break;
				
				case MISC_ONSCREENLED: {
					if (!bInitialized) write_text(leftMargin, menuLine,text_str_status_line);
					
					if ((!mainMenu_showStatus)&&((misc_menu[c]!=MISC_ONSCREENLED)||(!bb)))
						write_text_inv(tabstop3,menuLine, "Off");
					else
						write_text_norm(tabstop3, menuLine, "Off");
					if ((mainMenu_showStatus)&&((misc_menu[c]!=MISC_ONSCREENLED)||(!bb)))
						write_text_inv(tabstop5, menuLine,"On");
					else
						write_text_norm(tabstop5, menuLine,"On");
				}break;
				
				case MISC_SNAPSHOT: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Enable Screenshot");
					
					if ((mainMenu_enableScreenshots)&&((misc_menu[c]!=MISC_SNAPSHOT)||(!bb)))
						write_text_inv(tabstop3,menuLine,"Yes");
					else
						write_text_norm(tabstop3,menuLine,"Yes");
					
					if ((!mainMenu_enableScreenshots)&&((misc_menu[c]!=MISC_SNAPSHOT)||(!bb)))
						write_text_inv(tabstop5,menuLine,"No");
					else
						write_text_norm(tabstop5,menuLine,"No");
				}break;
				
				case MISC_ENABLESCRIPTS: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Enable scripts");
					
					if ((mainMenu_enableScripts)&&((misc_menu[c]!=MISC_ENABLESCRIPTS)||(!bb)))
						write_text_inv(tabstop3,menuLine,"Yes");
					else
						write_text_norm(tabstop3,menuLine,"Yes");
					
					if ((!mainMenu_enableScripts)&&((misc_menu[c]!=MISC_ENABLESCRIPTS)||(!bb)))
						write_text_inv(tabstop5,menuLine,"No");
					else
						write_text_norm(tabstop5,menuLine,"No");
					
				}break;	
				
				case MISC_SPLASHSCREEN: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Splash Screen");
					
					if ((!skipintro)&&((misc_menu[c]!=MISC_SPLASHSCREEN)||(!bb)))
						write_text_inv(tabstop3,menuLine,"Yes");
					else
						write_text_norm(tabstop3,menuLine,"Yes");
					
					if ((skipintro)&&((misc_menu[c]!=MISC_SPLASHSCREEN)||(!bb)))
						write_text_inv(tabstop5,menuLine,"No");
					else
						write_text_norm(tabstop5,menuLine,"No");
					
				}break;
				
				case MISC_KICKSTART: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Kickstart");
					
					if ((kickstart==0)&&((misc_menu[c]!=MISC_KICKSTART)||(!bb)))
						write_text_inv(tabstop3,menuLine,"1.2");
					else
						write_text_norm(tabstop3,menuLine,"1.2");
					
					if ((kickstart==1)&&((misc_menu[c]!=MISC_KICKSTART)||(!bb)))
						write_text_inv(tabstop5,menuLine,"1.3");
					else
						write_text_norm(tabstop5,menuLine,"1.3");
					
					if ((kickstart==2)&&((misc_menu[c]!=MISC_KICKSTART)||(!bb)))
						write_text_inv(tabstop7,menuLine,"2.0");
					else
						write_text_norm(tabstop7,menuLine,"2.0");
					
					if ((kickstart==3)&&((misc_menu[c]!=MISC_KICKSTART)||(!bb)))
						write_text_inv(tabstop9,menuLine,"3.1");
					else
						write_text_norm(tabstop9,menuLine,"3.1");
					
				}break;		
				
				case MISC_HWSCALING: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Enable HW scaling");
					
					if ((enableHWscaling)&&((misc_menu[c]!=MISC_HWSCALING)||(!bb)))
						write_text_inv(tabstop5,menuLine,"Yes");
					else
						write_text_norm(tabstop5,menuLine,"Yes");
					
					if ((!enableHWscaling)&&((misc_menu[c]!=MISC_HWSCALING)||(!bb)))
						write_text_inv(tabstop7,menuLine,"No");
					else
						write_text_norm(tabstop7,menuLine,"No");
					
				}break;
				
				case MISC_CONTROLCONFIG: {
					if (!bInitialized) write_text(leftMargin,menuLine,"Control config");
					
					if ((mainMenu_joyConf==0)&&((misc_menu[c]!=MISC_CONTROLCONFIG)||(!bb)))
						write_text_inv(tabstop5,menuLine,"0");
					else
						write_text_norm(tabstop5,menuLine,"0");
					
					if ((mainMenu_joyConf==1)&&((misc_menu[c]!=MISC_CONTROLCONFIG)||(!bb)))
						write_text_inv(tabstop6,menuLine,"1");
					else
						write_text_norm(tabstop6,menuLine,"1");
					
					if ((mainMenu_joyConf==2)&&((misc_menu[c]!=MISC_CONTROLCONFIG)||(!bb)))
						write_text_inv(tabstop7,menuLine,"2");
					else
						write_text_norm(tabstop7,menuLine,"2");
					
					if (mainMenu_joyConf==0) write_text(5,menuLine,"Standard buttons");
					else if (mainMenu_joyConf==1) write_text(5,menuLine,"Jump=X - Button 1=B");
					else if (mainMenu_joyConf==2) write_text(5,menuLine,"Jump=B - Button 1=X");
				}break;
			}
		}
		
		/* Options with configuration written in the following line - skip that line */
		switch (misc_menu[menuItem])
		{
			case MISC_PADCONFIG:
				menuLine+=2;
				break;
		}
		menuLine+=2;
		menuItem++;
	}
	
	text_flip();
	
	/* Last active option */
	c_last = c;
	
	/* Window has been completely drawn */
	bInitialized = true;
}

void update_joystick(int& left, int& right, int& up, int& down);

static int key_miscMenu(int *cp)
{
	int c=(*cp);
	int end=0;
	int left=0, right=0, up=0, down=0;
	int hit0=0, hit1=0, hit2=0, hit3=0, hit4=0, hit5=0;
	SDL_Joystick *joy = uae4all_joy0 ;
	
#ifndef __SYMBIAN32__
	SDL_JoystickUpdate ();
#endif
	
#ifndef __SYMBIAN32__
	if (SDL_JoystickGetButton(joy, GP2X_BUTTON_RIGHT)) right=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_LEFT)) left=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_UP)) up=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_DOWN)) down=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_B)) hit0=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_START)) {printf("Pressed Start\n");hit1=1;}
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_X)) hit0=1;
#endif
	
	SDL_Event event;
	
	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
			end=-1;
		else if (event.type == SDL_JOYBUTTONDOWN)
		{
			switch (event.jbutton.button)
			{
#ifdef __SYMBIAN32__
				case 0:hit0=1; break;
				case 1:
				case 2:hit1=1;break;
#else
				case GP2X_BUTTON_UP: up=1; break;
				case GP2X_BUTTON_LEFT: left=1; break;
				case GP2X_BUTTON_RIGHT: right=1; break;
				case GP2X_BUTTON_DOWN: down=1; break;
				case GP2X_BUTTON_X: hit0=1; break;
				case GP2X_BUTTON_B: hit0=1; break;
				case GP2X_BUTTON_START: hit1=1; break;
#endif
			}
		}	
		else
			if (event.type == SDL_KEYDOWN)
			{
				uae4all_play_click();
				switch(event.key.keysym.sym)
				{
					case SDLK_RIGHT: right=1; break;
					case SDLK_LEFT: left=1; break;
					case SDLK_UP: up=1; break;
					case SDLK_DOWN: down=1; break;
					case SDLK_RETURN:
					case SDLK_LCTRL: hit0=1; break;
					case SDLK_ESCAPE:
					case SDLK_LALT: hit1=1; break;
					case SDLK_1: end = EMENU_MAIN; break;
					case SDLK_2: break;
					case SDLK_3: miscMenu_case = MISC_MENU_CASE_MEMDISK; end = EMENU_MEMDISK; break;
					default:
						break;
				}
			}
	}
	
#ifdef __SYMBIAN32__
	update_joystick(left, right, up, down);
#endif
	
	/* Interval for checking key/joy events */
	if (!CheckKeyJoyRefresh(
			left, right, up, down,
			hit0, hit1, hit2, hit3, hit4, hit5,
			0))
		return 0;
	
	if (hit0)
	{
		end =-1;
	}
	else if (hit1)
	{
		end=-1;
	}
	else if (up)
	{
		c--;
		if (c < 0) c = sizeof(misc_menu)-2;
		if (misc_menu[c] == MISC_SEPARATOR) c--;
	}
	else if (down)
	{
		if(misc_menu[c+1] != 0)
		{
			c++;
			if (misc_menu[c] == MISC_SEPARATOR) c++;
		}
		else
		{
			c = 0;
		}			
	}
	
	switch (misc_menu[c])
	{
		case MISC_DISKMENU:
			/* Main Menu / Memory & Disk Menu */			
			if (hit0 || hit1)
			{
				/* Invalidate/redraw menu window */
				gActiveMenu_last = EMENU_NONE;
				end = 0;
				run_menuMemDisk();
			}
			break;
		case MISC_SCROFFSETX:
			if (left) {
				if (mainMenu_moveX > -MAX_MOVE_X) {
					mainMenu_moveX--;
				}
			} else if (right) {
				if (mainMenu_moveX < MAX_MOVE_X) {
					mainMenu_moveX++;
				}
			} else if (hit1) {
				mainMenu_moveX = 0;
			}
         moveHorizontal(mainMenu_moveX);
			/* Don't return to main menu with C (escape) key*/
			if (end < 0) end = 0;
			break;
		case MISC_SCROFFSETY:
			if (left) {
				if (mainMenu_moveY > -MAX_MOVE_Y) {
					mainMenu_moveY--;
				}
			} else if (right) {
				if (mainMenu_moveY < MAX_MOVE_Y) {
					mainMenu_moveY++;
				}
			} else if (hit1) {
				mainMenu_moveY = 0;
			}
         moveVertical(mainMenu_moveY);
			/* Don't return to main menu with C (escape) key*/
			if (end < 0) end = 0;
			break;
		case MISC_REMAPPINGMENU:
			if(hit0 || hit1) 
			{
				/* Invalidate/redraw menu window */
				gActiveMenu_last = EMENU_NONE;
				end = 0;
				run_menuRemapping();
			}
			break;
      case MISC_CPU:
         if (left) {
            if (mainMenu_CPU_model > 0)
               mainMenu_CPU_model--;
            else
               mainMenu_CPU_model=1;
         } else if (right) {
            if (mainMenu_CPU_model < 1)
               mainMenu_CPU_model++;
            else
               mainMenu_CPU_model=0;
         }
         switch (mainMenu_CPU_model) {
            case 1: changed_prefs.cpu_level = M68020; break;
            default: changed_prefs.cpu_level = M68000; break;
         }
         break;
		case MISC_CHIPSET:
			if (left) {
				if (mainMenu_chipset > 0)
					mainMenu_chipset--;
				else
					mainMenu_chipset=2;
			} else if (right) {
				if (mainMenu_chipset < 2)
					mainMenu_chipset++;
				else
					mainMenu_chipset=0;
			}
			switch (mainMenu_chipset) {
				case 1: changed_prefs.chipset_mask = CSMASK_ECS_AGNUS | CSMASK_ECS_DENISE; break;
				case 2: changed_prefs.chipset_mask = CSMASK_ECS_AGNUS | CSMASK_ECS_DENISE | CSMASK_AGA; break;
				default: changed_prefs.chipset_mask = CSMASK_ECS_AGNUS; break;
			}
			break;
		case MISC_VIDEOMODE:
			if ((left)||(right))
			{
				mainMenu_ntsc = !mainMenu_ntsc;
			}
			break;
		case MISC_AUTOSAVE:
			if ((left)||(right))
			{
				mainMenu_autosave = (mainMenu_autosave == 0) ? 1 : 0;
			}
			break;
		case MISC_NODRIVES:
			if (left)
			{
				if (nr_drives>1)
					nr_drives--;
				else
					nr_drives=4;
			}
			else if (right)
			{
				if (nr_drives<4)
					nr_drives++;
				else
					nr_drives=1;
			}	
			break;
		case MISC_AUTOFIRE:
			if ((left)||(right))
			{
				mainMenu_autofire = !mainMenu_autofire;
			}
			break;
		case MISC_ONSCREENLED:
		{
			if ((left)||(right))
				mainMenu_showStatus=!mainMenu_showStatus;
		}   break;
		case MISC_SNAPSHOT:
		{
			if ((left)||(right))
				mainMenu_enableScreenshots=!mainMenu_enableScreenshots;
		}   break;
		case MISC_ENABLESCRIPTS:
		{
			if ((left)||(right))
				mainMenu_enableScripts=!mainMenu_enableScripts;
		}   break;
		case MISC_SPLASHSCREEN:
		{
			if ((left)||(right))
				skipintro=!skipintro;
		}   break;
		case MISC_KICKSTART:
			if (left)
			{
				if (kickstart>0)
					kickstart--;
				else
					kickstart=3;
			}
			else if (right)
			{
				if (kickstart<3)
					kickstart++;
				else
					kickstart=0;
			}	break;
			
		case MISC_HWSCALING:
		{
			if ((left)||(right))
				enableHWscaling=!enableHWscaling;
		}   break;
		
		case MISC_CONTROLCONFIG:
			if (left || right)
			{
				left?mainMenu_joyConf--:mainMenu_joyConf++;
				if (mainMenu_joyConf<0)
					mainMenu_joyConf=2;
				else if(mainMenu_joyConf > 2)
					mainMenu_joyConf=0;
			}break;
		case MISC_PADCONFIG:
			if (left)
			{
				if (mainMenu_keypadConf>0)
					mainMenu_keypadConf--;
				else
					mainMenu_keypadConf=7;
			}
			else if (right)
			{
				if (mainMenu_keypadConf<7)
					mainMenu_keypadConf++;
				else
					mainMenu_keypadConf=0;
			}	break;
	}
	
	(*cp)=c;
	return end;
}

static void raise_miscMenu()
{
#ifndef __SYMBIAN32__
	int i;

	text_draw_background();
	text_flip();
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(80-64,(10-i)*24,160+64+64,220,text_str_misc_title);
		text_flip();
	}
#endif
}

static void unraise_miscMenu()
{
#ifndef __SYMBIAN32__
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(80-64,(10-i)*24,160+64+64,220,text_str_misc_title);
		text_flip();
	}
	text_draw_background();
	text_flip();
#endif
}
int run_menuMisc()
{
	static int c=0;
	int end=0;
	SDL_Event event;
	
	SDL_Delay(150);
	while(SDL_PollEvent(&event))
		SDL_Delay(10);
	raise_miscMenu();
	
	while(!end)
	{
		miscMenu_case = -1;
		
		draw_miscMenu(c);
		SDL_Delay(EVENT_POLLING_INTERVAL);
		end=key_miscMenu(&c);
		
		switch(end)
		{
			case EMENU_MEMDISK:
				end = run_menuMemDisk();
				break;
		}
	}
	
	unraise_miscMenu();
	
	set_joyConf();
	
	return end;
}
