
#ifndef NO_MENU

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include "menu.h"
#include "sysconfig.h"
#include "sysdeps.h"
#include "uae.h"
#include "options.h"
#include "sound.h"
#include <SDL.h>
#include "gp2x.h"
#include "vkbd.h"
#include <SDL_ttf.h>

static char *text_str_title="KEY MAPPING";
static char *text_str_separator="----------------------";
static char *text_str_exit="Back to Last Menu";
static char *text_str_remap="Remap Key";
extern int emulating;
extern SDL_Joystick *uae4all_joy0;
int remappingMenu_case=-1;
int remapping_select = 0;
int remapping_index = -1;
int keymappings[10][3];

enum { 	
	REMAPPING_MENU_CASE_EXIT = 1, 
	REMAPPING_MENU_REMAP, 
	REMAPPING_MENU_CASE_CANCEL,
	REMAPPING_SEPARATOR,
	REMAPPING_MENU_1,
	REMAPPING_MENU_2,
	REMAPPING_MENU_3,
	REMAPPING_MENU_4,
	REMAPPING_MENU_5,
	REMAPPING_MENU_6,
	REMAPPING_MENU_7,
	REMAPPING_MENU_8,
	REMAPPING_MENU_9,
	REMAPPING_MENU_10};

const char remap_menu[]=
		{
			REMAPPING_MENU_1,
			REMAPPING_MENU_2,
			REMAPPING_MENU_3,
			REMAPPING_MENU_4,
			REMAPPING_MENU_5,
			REMAPPING_MENU_6,
			REMAPPING_MENU_7,
			REMAPPING_MENU_8,
			REMAPPING_MENU_9,
			REMAPPING_MENU_10,
			REMAPPING_SEPARATOR,
			//REMAPPING_MENU_REMAP,
			REMAPPING_MENU_CASE_EXIT,
			//REMAPPING_SEPARATOR,
			0
	};

static void show_info(char *title, char* info)
{
	text_draw_background();
	
	text_draw_window(4,4,38,20,title);
	write_text(6,9, info);
}

static inline void draw_remappingMenu(int c)
{
	int curLine = 6;
	int curItem = 0;
	extern SDL_Surface *text_screen;
	
	static bool bb = false;		/* Inverted/normal selection drawing */
	static int c_last;			/* Last selection */
	static bool bInitialized;	/* Window is drawn only once, except when menu changes */
	
   if(remapping_select)
   {
      if(remapping_select == 1)
      {
         show_info("REMAP KEY", "Please select AMIGA key to map:");
         SDL_BlitSurface(text_screen,NULL,prSDLScreen,NULL);
//       if(vkbd_move)
//       {
//          SDL_Delay(100);
//       }
         SDLKey key = vkbd_process();
//         vkbd_move = 0;
         if(key != 0)
         {
            remapping_select++;
            keymappings[remapping_index][1] = key;
         }
      }
      else
      {
         show_info("REMAP KEY", "Please press key/button to map");
         SDL_BlitSurface(text_screen,NULL,prSDLScreen,NULL);
      }
      SDL_Flip(prSDLScreen);
   }
   else
   {
      text_flip();
   }

   /* Should menu window be refreshed ? */
	if (!CheckMenuRefresh(EMENU_REMAPPING, c, c_last, &bb, &bInitialized))
		return;

	if (!bInitialized) {
		text_draw_background();
		text_draw_window(4,4,38,25,text_str_title);
	}
	
	while(remap_menu[curItem] != 0)
	{
		if (remap_menu[curItem]==REMAPPING_SEPARATOR)
		{
			curLine--;
			write_text(9,curLine,text_str_separator);
		} else if (curItem > 0) {
			if (remap_menu[curItem-1]==REMAPPING_SEPARATOR)
				curLine--;
		}

		if ((c==curItem)||(c_last==curItem)||!bInitialized ) {
			switch(remap_menu[curItem]) {
				case 	REMAPPING_MENU_1:
				case 	REMAPPING_MENU_2:
				case 	REMAPPING_MENU_3:
				case 	REMAPPING_MENU_4:
				case 	REMAPPING_MENU_5:
				case 	REMAPPING_MENU_6:
				case 	REMAPPING_MENU_7:
				case 	REMAPPING_MENU_8:
				case 	REMAPPING_MENU_9:
				case 	REMAPPING_MENU_10:
				{
					char charmap[32];
					int item = remap_menu[curItem]-REMAPPING_MENU_1;

					if( keymappings[item][0] >= 0)
					{				
						if( keymappings[item][2]) {
							sprintf(charmap,"%2d %s - %d", item+1, SDL_GetKeyName((SDLKey) keymappings[item][0]), keymappings[item][1]);
						}
						else
						{
							sprintf(charmap,"%2d %s - %s", item+1, SDL_GetKeyName((SDLKey) keymappings[item][0]), SDL_GetKeyName((SDLKey) keymappings[item][1]));
						}				
					}
					else
					{
						sprintf(charmap, "%2d Empty", item+1);					
					}

					if ((remap_menu[c] == remap_menu[curItem]) && (bb))
						write_text_inv(9, curLine, charmap, 30);
					else
						write_text_norm(9, curLine, charmap, 30);
				}
				break;
				
				case REMAPPING_MENU_REMAP:
					if ((remap_menu[c]==REMAPPING_MENU_REMAP)&&(bb))
						write_text_inv(9,curLine,text_str_remap);
					else
						write_text_norm(9,curLine,text_str_remap);
					break;
					
				case REMAPPING_MENU_CASE_EXIT:
					if ((remap_menu[c]==REMAPPING_MENU_CASE_EXIT)&&(bb))
						write_text_inv(9,curLine,text_str_exit);
					else
						write_text_norm(9,curLine,text_str_exit);
					break;
			}
		}
		curLine+=2;
		curItem++;
	}
	
	/* Last active option */
	c_last = c;
	
	/* Window has been completely drawn */
	bInitialized = true;
}

void update_joystick(int& left, int& right, int& up, int& down);

static inline int key_remappingMenu(int *cp)
{
	int c=(*cp);


	int end=0;

	int left=0, right=0, up=0, down=0;
	int hit0=0, hit1=0;
	int hit2=0, hit3=0, hit4=0, hit5=0;

	SDL_Joystick *joy = uae4all_joy0;

   SDL_JoystickUpdate();
   
#if defined PANDORA || defined __SYMBIAN32__
	if (SDL_JoystickGetAxis(joy, 0) > 0) {
		if (remapping_select)
		{
			vkbd_move |= VKBD_RIGHT;
		}
//		else
			right = 1;
	} else if (SDL_JoystickGetAxis(joy, 0) < 0) {
		if (remapping_select)
		{
			vkbd_move |= VKBD_LEFT;
		}
//		else
			left = 1;
	} else if (SDL_JoystickGetAxis(joy, 1) < 0) {
		if (remapping_select)
		{
			vkbd_move |= VKBD_UP;
		}
//		else
			up = 1;
	} else if (SDL_JoystickGetAxis(joy, 1) > 0) {
		if (remapping_select)
		{
			vkbd_move |= VKBD_DOWN;
		}
//		else
			down = 1;
	}
	if (SDL_JoystickGetButton(joy, 0)) {
		if(remapping_select)
		{
			vkbd_move |= VKBD_BUTTON;
		}
//		else
		{
			hit0=1;
		}
	}
	if (SDL_JoystickGetButton(joy, 1) ||  SDL_JoystickGetButton(joy,2)) {
		if(remapping_select)
		{
			vkbd_move |= VKBD_BUTTON2;
		}
//		else
		{
			hit1=1;
		}
	}
#else
	if (SDL_JoystickGetButton(joy, GP2X_BUTTON_RIGHT)) right=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_LEFT)) left=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_UP)) up=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_DOWN)) down=1;
#endif	
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_B)) hit0=1;
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_START)) {printf("Pressed Start\n");hit1=1;}
	else if (SDL_JoystickGetButton(joy, GP2X_BUTTON_X)) hit0=1;
	
	SDL_Event event;

	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
		{
			remappingMenu_case=REMAPPING_MENU_CASE_EXIT;
			end=-1;
		}
		else {
			if(event.type == SDL_JOYBUTTONDOWN) {
			   if (remapping_select == 2)
            {
               /* Invalidate window */
               gActiveMenu_last = EMENU_NONE;

//               switch (event.jbutton.button)
//               {
//#ifdef __SYMBIAN32__
//                  case 0:hit0=1; break;
//#endif
//               }
               remapping_select = 0;
               vkbd_move = 0;
               keymappings[remapping_index][0] = event.jbutton.button;
               keymappings[remapping_index][2] = 1;
//               SDL_Delay(50);
            }
			} else {
				if (event.type == SDL_KEYDOWN)
				{
					uae4all_play_click();
					
					if(remapping_select == 2)
					{
	               /* Invalidate window */
	               gActiveMenu_last = EMENU_NONE;
	               
//	               switch(event.key.keysym.sym) {
//	                  case SDLK_z:
//                     case SDLK_RETURN:
//                     case SDLK_e:
//                     case SDLK_LCTRL:
//                           hit0 = 1;
//                           break;
//	               }
                  remapping_select = 0;
                  vkbd_move = 0;
	               keymappings[remapping_index][0] = event.key.keysym.sym;
						keymappings[remapping_index][2] = 0;
//						SDL_Delay(50);
					}
					else {
						switch(event.key.keysym.sym)
						{
							case SDLK_d:
							case SDLK_RIGHT:
								if (remapping_select)
								{
									vkbd_move |= VKBD_RIGHT;
								}
								else
									right = 1;
								break;
							case SDLK_a:
							case SDLK_LEFT:
								if (remapping_select)
								{
									vkbd_move |= VKBD_LEFT;
								}
								else
									left = 1;
								break;
							case SDLK_w:
#ifdef MAEMO_CHANGES
							case SDLK_PRINT: // UP on Maemo SDK SIC! //
#endif
							case SDLK_UP:
								if (remapping_select)
								{
									vkbd_move |= VKBD_UP;
								}
								else
									up = 1;
								break;
							case SDLK_s:
#ifdef MAEMO_CHANGES
							case SDLK_RSUPER: // DOWN on Maemo SDK SIC! //
#endif
							case SDLK_DOWN:
								if (remapping_select)
								{
									vkbd_move |= VKBD_DOWN;
								}
								else
									down = 1;
								break;
							case SDLK_z:
							case SDLK_RETURN:
							case SDLK_e:
							case SDLK_LCTRL:
								if (remapping_select)
								{
									vkbd_move |= VKBD_BUTTON;
								}
								else
									hit0 = 1;
								break;
#ifdef DREAMCAST
							case SDLK_2:
							case SDLK_BACKSPACE: hit2=1; break;
							case SDLK_1:
							case SDLK_TAB: hit3=1; break;
							case SDLK_x:				
							case SDLK_c:
							case SDLK_LSHIFT: hit5=1; break;
#else				
							case SDLK_ESCAPE:
							case SDLK_BACKSPACE:
							   hit2=1; break;	
							case SDLK_TAB:				
							case SDLK_SPACE:
								if (remapping_select)
								{
									vkbd_move |= VKBD_BUTTON;
								}
								else
									hit1 = 1;
								break;
							default:
								break;

#endif				
						}
					}
				}
			}
		}
	}
	
	/* Convert vkbd_move to local variables */
	if (/*remapping_select &&*/ vkbd_move) {
	   if (vkbd_move&VKBD_BUTTON)
	      hit0 = 1;
	   else if (vkbd_move&VKBD_BUTTON2)
	      hit1 = 1;
	   else if (vkbd_move&VKBD_LEFT)
	      left = 1;
      else if (vkbd_move&VKBD_RIGHT)
         right = 1;
      else if (vkbd_move&VKBD_UP)
         up = 1;
      else if (vkbd_move&VKBD_DOWN)
         down = 1;
	}
	
   /* Interval for checking key/joy events */
   if (!CheckKeyJoyRefresh(
         left, right, up, down,
         hit0, hit1, hit2, hit3, hit4, hit5,
         0)) {
      /* Clear all key events */
      while(SDL_PollEvent(&event))
         SDL_Delay(10);
      vkbd_move = 0;
      return 0;
   }
   
   if (remapping_select)
      return 0;
   
   if (up)
	{
		if (c > 0)
			c--;
		else
		{
			c = sizeof(remap_menu) - 2;
		}
		if (remap_menu[c] == REMAPPING_SEPARATOR) c--;
	}
	else if (down)
	{
		c++;
		if (c > sizeof(remap_menu) - 2)
		{
			c = 0;
		}
		if (remap_menu[c] == REMAPPING_SEPARATOR) c++;
	}
	else
		switch (remap_menu[c])
		{
			case 	REMAPPING_MENU_1:
			case 	REMAPPING_MENU_2:
			case 	REMAPPING_MENU_3:
			case 	REMAPPING_MENU_4:
			case 	REMAPPING_MENU_5:
			case 	REMAPPING_MENU_6:
			case 	REMAPPING_MENU_7:
			case 	REMAPPING_MENU_8:
			case 	REMAPPING_MENU_9:
			case 	REMAPPING_MENU_10:
			{
				int item = remap_menu[c]-REMAPPING_MENU_1;
				if(hit2)
				{

					keymappings[item][0] = -1;
					keymappings[item][1] = -1;
					keymappings[item][2] = -1;
				}
				else if(hit0)
				{
				   remapping_index = item;
					remapping_select = 1;
				}
			}
			break;

//			case REMAPPING_MENU_REMAP:
//				if (hit0)
//				{
//					int i;
//					for(i = 0;i<10;i++) {
//						if(keymappings[i][0] == -1)
//						{
//							remapping_index = i;
//							remapping_select = 1;
//							break;
//						}
//					}					
//				}
//				break;

			case REMAPPING_MENU_CASE_EXIT:
				if (hit0)
				{
					/* Invalidate/redraw menu window */
					gActiveMenu_last = EMENU_NONE;
					remappingMenu_case = REMAPPING_MENU_CASE_EXIT;
					end = 1;
				}
				break;
		}
   
	(*cp)=c;
	return end;
}

static inline void raise_remappingMenu()
{
	int i;

//	uae4all_play_save();
	text_draw_background();
	text_flip();
	for(i=0;i<8;i++)
	{
		text_draw_background();
		text_draw_window(128-(8*i),(8-i)*24,144+(8*i),172,"Remappings");
		text_flip();
//		SDL_Delay(15);
	}
}

static inline void unraise_remappingMenu()
{
	int i;

	for(i=7;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(128-(8*i),(8-i)*24,144+(8*i),160,"");
		text_flip();
//		SDL_Delay(15);
	}
	text_draw_background();
	text_flip();
}

int run_menuRemapping()
{
	static int c=0;
	int end;
   SDL_Event event;
   
   SDL_Delay(150);
   while(SDL_PollEvent(&event))
      SDL_Delay(10);

   remappingMenu_case=-1;
	vkbd_init();

   while(remappingMenu_case<0)
	{
      while(SDL_PollEvent(&event))
         SDL_Delay(10);
		raise_remappingMenu();
		end=0;
		while(!end)
		{
			draw_remappingMenu(c);
	      SDL_Delay(2*EVENT_POLLING_INTERVAL);
			end=key_remappingMenu(&c);
		}
		unraise_remappingMenu();
		
	   switch(remappingMenu_case)
		{
			case REMAPPING_MENU_REMAP:
			{
				remapping_select = 1;
				remappingMenu_case=-1;
			}break;
			case REMAPPING_MENU_CASE_EXIT:	
			case REMAPPING_MENU_CASE_CANCEL:	
				remappingMenu_case=1;
				break;
			default:
				remappingMenu_case=-1;
		}
	}
	vkbd_quit();
	return remappingMenu_case;
}
#endif
