#ifndef CFGFILE_H_
#define CFGFILE_H_

extern char * make_hard_dir_cfg_line (char *dst);
extern char * make_hard_file_cfg_line (char *dst);
extern void parse_filesys_spec (int readonly, char *spec);
extern void parse_hardfile_spec (char *spec);

#ifndef __SYMBIAN32__
extern char *cfgfile_subst_path (const char *path, const char *subst, const char *file);
extern int match_string (const char *table[], const char *str);
extern void save_options (FILE *f, struct uae_prefs *p);
extern int cfgfile_yesno (char *option, char *value, char *name, int *location);
extern int cfgfile_intval (char *option, char *value, char *name, int *location, int scale);
extern int cfgfile_strval (char *option, char *value, char *name, int *location, const char *table[], int more);
extern int cfgfile_string (char *option, char *value, char *name, char *location, int maxsz);
extern int getintval (char **p, int *result, int delim);
extern void set_chipset_mask (uae_prefs *p, int val);
extern int cfgfile_parse_option (uae_prefs *p, char *option, char *value);
extern void cfgfile_parse_line (uae_prefs *p, char *line);
extern void subst (char *p, char *f, int n);
extern int cfgfile_load (uae_prefs *p, const char *filename);
extern int cfgfile_save (uae_prefs *p, const char *filename);
extern int cfgfile_get_description (const char *filename, char *description);
extern void cfgfile_show_usage (void);
extern void parse_gfx_specs (char *spec);
extern void parse_sound_spec (char *spec);
extern void parse_joy_spec (char *spec);
extern void parse_cpu_specs (char *spec);
extern int parse_cmdline_option (char c, char *arg);
#endif

#endif
